﻿using System;
using System.Collections.Generic;

namespace GlobalCF
{
	public static class RSR2_BMPK_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xFA,
				DriverType = GKDriverType.RSR2_BMPK,
				UID = new Guid("5954D868-CAD7-47DE-AD13-87A49E07C5B7"),
				Name = "Кнопка БМП",
				ShortName = "БМПК",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.Other,
				IsAutoCreate = true
			};

			driver.AvailableStateBits.Add(GKStateBit.Fire1);
			driver.AvailableStateBits.Add(GKStateBit.Failure);

			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.On);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Off);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Fire1);

			GKDriversHelper.AddEnumProprety(driver, 0, "Конфигурация", 0, new List<string> { "НЗ", "НР" });

			return driver;
		}
	}
}
