﻿using System;

namespace GlobalCF
{
	public static class RSR2_BMPP_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xFC,
				DriverType = GKDriverType.RSR2_BMPP,
				UID = new Guid("D2DD5E51-DC72-4106-8054-78B136B10A18"),
				Name = "Питание БМП",
				ShortName = "БМПП",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.Other,
				IsAutoCreate = true
			};

			driver.AvailableStateBits.Add(GKStateBit.Failure);
			
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.On);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Off);
			
			GKDriversHelper.AddIntProprety(driver, 0, "Порог Питание 1, 0.1B", 100, 0, 180);
			GKDriversHelper.AddIntProprety(driver, 1, "Порог Питание 2, 0.1B", 100, 0, 180);
			GKDriversHelper.AddIntProprety(driver, 2, "Порог Деградация АКБ, Ом", 100, 0, 65535);

			driver.MeasureParameters.Add(new GKMeasureParameter { Name = "Питание 1, B" });
			driver.MeasureParameters.Add(new GKMeasureParameter { Name = "Питание 2, B" });
			driver.MeasureParameters.Add(new GKMeasureParameter { Name = "Деградация АКБ, Ом" });
			driver.MeasureParameters.Add(new GKMeasureParameter { Name = "Ток АКБ, мА" });

			return driver;
		}
	}
}
