﻿using System;
using System.Collections.Generic;

namespace GlobalCF
{
	public static class RSR2_BMPUI_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xFB,
				DriverType = GKDriverType.RSR2_BMPUI,
				UID = new Guid("F388F0E0-001E-4BAE-89DE-0B512A684324"),
				Name = "Исполнительное устройство БМП",
				ShortName = "БМПУИ",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.ActuatingDevice,
				IsAutoCreate = true
			};

			GKDriversHelper.AddControlAvailableStates(driver);
			driver.AvailableStateBits.Add(GKStateBit.Off);
			driver.AvailableStateBits.Add(GKStateBit.Failure);
			driver.AvailableStateBits.Add(GKStateBit.Test);
			
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.On);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Off);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.AutoOff);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);

			GKDriversHelper.AddIntProprety(driver, 0, "Порог КЗ, Ом", 5, 0, 65535);
			GKDriversHelper.AddIntProprety(driver, 1, "Порог ОБР, Ом", 45, 0, 65535);
			GKDriversHelper.AddEnumProprety(driver, 2, "Тип подрыва", 0, new List<string> { "12В", "24В" });

			driver.MeasureParameters.Add(new GKMeasureParameter() { No = 1, Name = "Сопротивление, Ом", InternalName = "Resistance" });

			return driver;
		}
	}
}
