﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;
using System.Windows.Markup;

namespace Converters
{
	/// <summary>
	/// Convert Level to left margin
	/// Pass a prarameter if you want a unit length other than 19.0.
	/// </summary>
	public class LevelToIndentConverter : MarkupExtension, IValueConverter
	{
		private const double IndentSize = 19.0;

		static LevelToIndentConverter _converter = null;
		public override object ProvideValue(IServiceProvider serviceProvider)
		{
			if (_converter == null)
			{
				_converter = new LevelToIndentConverter();
			}
			return _converter;
		}
		public object Convert(object o, Type type, object parameter, CultureInfo culture)
		{
			Double indentSize = 19;
			if (parameter != null)
				Double.TryParse(parameter.ToString(), out indentSize);

			return new Thickness((int)o * IndentSize, 0, 0, 0);
		}

		public object ConvertBack(object o, Type type, object parameter, CultureInfo culture)
		{
			throw new NotSupportedException();
		}

	}

}
