﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows;
using System.Windows.Media;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using System.IO;
using System.Xml;

namespace GlobalCF
{
    public class GKDevice : INotifyPropertyChanged
	{
		public List<MessageCS> deviceMessagesList = new List<MessageCS>();
		public MyData DataFromDevice { set; get; }
		ushort _AddCCstate = 0;
		public Dictionary<byte, string> StateWord1 = new Dictionary<byte, string>();
		public Dictionary<byte, string> StateWord2 = new Dictionary<byte, string>();
		public Dictionary<byte, string> CMDControls = new Dictionary<byte, string>();
		public List<string> CmdNames;

		public ushort AddCCstate
        {
            set
            {
				if (value != this._AddCCstate)
                {
					this._AddCCstate = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Слово состояния №2 = " + value));
					this.OnPropertyChanged();
                }                
            }
            get { return this._AddCCstate; }
        }
		public bool PrevTestState = false;
		bool _TestState;
		public bool TestState
		{
			set
			{
				if (((value) && (!this._TestState)) || ((!value) && (this._TestState)))
				{
					this._TestState = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Тест = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._TestState; }
		}
		public bool PrevFailureState = false;
		bool _FailureState;
		public bool FailureState
		{
			set
			{
				if (((value) && (!this._FailureState)) || ((!value) && (this._FailureState)))
				{
					this._FailureState = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Неисправность = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._FailureState; }
		}
		public bool PrevFire1 = false;
		bool _Fire1;
		public bool Fire1
		{
			set
			{
				if (((value) && (!this._Fire1)) || ((!value) && (this._Fire1)))
				{
					this._Fire1 = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Пожар1 = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._Fire1; }
		}
		public bool PrevFire2 = false;
		bool _Fire2;
		public bool Fire2
		{
			set
			{
				if (((value) && (!this._Fire2)) || ((!value) && (this._Fire2)))
				{
					this._Fire2 = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Пожар2 = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._Fire2; }
		}
		public bool PrevMode1 = false;
		bool _Mode1;
		public bool Mode1
		{
			set
			{
				if (((value) && (!this._Mode1)) || ((!value) && (this._Mode1)))
				{
					this._Mode1 = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Режим1 = " + value));
					if (this._Mode1) // _1
					{
						if (!this._Mode2) // 0_
						{
							this.Mode = 1; //автоматика включена
						}
						else // 1_
						{
							this.Mode = 3; //неизвестное
						}
					}
					else // _0
					{
						if (!this._Mode2) // 0_
						{
							this.Mode = 0; //ручное управление
						}
						else // 1_
						{
							this.Mode = 2; //отключение
						}
					}
					this.OnPropertyChanged();
				}
			}
			get { return this._Mode1; }
		}
		public bool PrevMode2 = false;
		bool _Mode2;
		public bool Mode2
		{
			set
			{
				if (((value) && (!this._Mode2)) || ((!value) && (this._Mode2)))
				{
					this._Mode2 = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Режим2 = " + value));
					if (this._Mode1) // _1
					{
						if (!this._Mode2) // 0_
						{
							this.Mode = 1; //автоматика включена
						}
						else // 1_
						{
							this.Mode = 3; //неизвестное
						}
					}
					else // _0
					{
						if (!this._Mode2) // 0_
						{
							this.Mode = 0; //ручное управление
						}
						else // 1_
						{
							this.Mode = 2; //отключение
						}
					}
					this.OnPropertyChanged();
				}
			}
			get { return this._Mode2; }
		}
		public bool PrevOnState = false;
		bool _OnState;
		public bool OnState
		{
			set
			{
				if (((value) && (!this._OnState)) || ((!value) && (this._OnState)))
				{
					this._OnState = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Включено = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._OnState; }
		}
		public bool PrevOffState = false;
		bool _OffState;
		public bool OffState
		{
			set
			{
				if (((value) && (!this._OffState)) || ((!value) && (this._OffState)))
				{
					this._OffState = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Отключено = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._OffState; }
		}
		public bool PrevOnAction = false;
		bool _OnAction;
		public bool OnAction
		{
			set
			{
				if (((value) && (!this._OnAction)) || ((!value) && (this._OnAction)))
				{
					this._OnAction = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Включение = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._OnAction; }
		}
		public bool PrevOffAction = false;
		bool _OffAction;
		public bool OffAction
		{
			set
			{
				if (((value) && (!this._OffAction)) || ((!value) && (this._OffAction)))
				{
					this._OffAction = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Сигнал Отключение = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._OffAction; }
		}
		public bool PrevConnectionState = false;
		bool _ConnectionState = false;
		public bool ConnectionState
        {
			set
			{
				if (((value) && (!this._ConnectionState)) || ((!value) && (this._ConnectionState)))
				{
					this._ConnectionState = value;
					//deviceMessagesList.Add(new MessageCS(DateTime.Now, "", this.Driver.ShortName, "Связь с АУ = " + value));
					this.OnPropertyChanged();
				}
			}
			get { return this._ConnectionState; }
		}
		byte _Mode = 0;
		public byte Mode
		{
			set
			{
				if (this._Mode != value)
				{
					this._Mode = value;
					this.OnPropertyChanged();
				}
			}
			get { return this._Mode; }
		}


		/// <summary>
		/// Идентификатор драйвера
		/// </summary>
		public Guid DriverUID { get; set; }
		int _intAddress;        
		/// <summary>
		/// Адрес
		/// </summary>
		public int IntAddress
		{
			get { return _intAddress; }
			set
			{
				_intAddress = value;
			}
		}
		public List<GKDevice> Devices
		{
			set; get;
		}
		/*public byte ShleifNo
		{
			get
			{
				var allParents = AllParents;
				var shleif = allParents.FirstOrDefault(x => x.DriverType == GKDriverType.RSR2_KAU_Shleif);
				if (shleif != null)
				{
					return (byte)shleif.IntAddress;
				}
				return 0;
			}
		}*/
		/*public List<GKDevice> AllParents
		{
			get
			{
				if (Parent == null)
					return new List<GKDevice>();

				List<GKDevice> allParents = Parent.AllParents;
				allParents.Add(Parent);
				return allParents;
			}
		}*/

		//public GKDevice Parent { get; set; }

		public GKDriverType DriverType => Driver.DriverType;

		GKDriver _driver;

		public event PropertyChangedEventHandler PropertyChanged = delegate { };

		public GKDriver Driver
		{
			get
			{
				return _driver;
			}
			set
			{
				switch (value.UID.ToString().ToUpper())
				{
					case "6260F52C-D047-4F64-BFE8-B9D0547A39B4": _driver = RSR2_ABPC_Helper.Create(); break;
					case "71B8E463-4927-4ECD-823E-D59179C9ED29": _driver = RSR2_ABShS_Group_Helper.Create(); break;
					case "7C464C3A-DDC5-496A-9747-4CA93B774DCA": _driver = RSR2_ABShS_Helper.Create(); break;
					case "D59115A5-B3A6-4D76-A744-0B719F81B15D": _driver = RSR2_ABTK_Group_Helper.Create(); break;
					case "45BA7A5E-BF4B-4F63-B80E-95FE422DC70D": _driver = RSR2_ABTK_Helper.Create(); break;
					case "860F3F6A-9EE9-437B-8220-B66AFDDBD285": _driver = RSR2_AM_1_Helper.Create(); break;
					case "F8496E34-8F48-436F-954C-79B6BA918BBB": _driver = RSR2_AM_2_Group_Helper.Create(); break;
					case "79EAC50A-D534-4775-A102-BE4872877400": _driver = RSR2_AM_4_Group_Helper.Create(); break;
					case "CCBABF42-F134-47E6-AF5F-51D82E5F77A5": _driver = RSR2_Button_Helper.Create(); break;
					case "08E8C44C-16B7-469F-AEEA-C48D32240682": _driver = RSR2_Buz_KV_Helper.Create(); break;
					case "56D46127-12C2-4D6C-BA9B-99503E897909": _driver = RSR2_Buz_KVDU_Helper.Create(); break;
					case "D37A46C3-0748-4E67-8D10-DD17C23E8F53": _driver = RSR2_Buz_KVMV_Helper.Create(); break;
					case "8DF7C57F-C788-4CE1-99F5-622A18AF4AF1": _driver = RSR2_CardReader_Helper.Create(); break;
					case "D296DEBC-8993-4798-A2BC-0410FB79E366": _driver = RSR2_CodeCardReader_Helper.Create(); break;
					case "1CCE48EB-B60B-4E06-8290-A39591CD3DA2": _driver = RSR2_CombinedDetector_Helper.Create(); break;
					case "1743FA7E-EF69-45B7-90CD-D9BF2B44644C": _driver = RSR2_DrenazhPump_Helper.Create(); break;
					case "6C9192C9-2841-46B6-B653-7834EFA41041": _driver = RSR2_FirePump_Helper.Create(); break;
					case "501AA41F-248B-4A4E-982A-6BC93505C7A9": _driver = RSR2_GuardDetector_Helper.Create(); break;
					case "38618571-FA63-4A8F-9D39-F16E36567E32": _driver = RSR2_GuardDetectorGuardSound_Helper.Create(); break;
					case "151881A2-0A39-4609-870F-4A84B2F8A4C8": _driver = RSR2_HandDetector_Helper.Create(); break;
					case "528DA6A8-F4DA-4FF6-93B8-2E355F33AFE4": _driver = RSR2_HandDetectorEridan_Helper.Create(); break;
					case "BD3A0139-D9FD-4224-B5D6-8772BA9E3760": _driver = RSR2_HandGuardDetector_Helper.Create(); break;
					case "C0A93D79-9A7F-46AF-A190-855F32759A05": _driver = RSR2_HeatDetector_Helper.Create(); break;
					case "ADC56B8F-0B5D-40E3-933A-9E97F3C8649F": _driver = RSR2_HeatDetectorEridan_Helper.Create(); break;
					case "DF7C55FE-AFCE-4202-9FA1-1E625B61288C": _driver = RSR2_IDMS_Helper.Create(); break;
					case "C0EE8FB4-FFE6-4E6B-A957-35206ED0E13B": _driver = RSR2_IMMS_Helper.Create(); break;
					case "10DCA010-257E-4D81-B090-72903E0CB029": _driver = RSR2_IOLIT_Helper.Create(); break;
					case "127CF67C-1275-4DC3-8AED-216FA29BCFA9": _driver = RSR2_IPS_Helper.Create(); break;
					case "F2D21F78-A237-4CFB-B61A-2D8B8B9163F6": _driver = RSR2_IS_Helper.Create(); break;
					case "CD3F6C78-F9E9-4386-AA14-C1472B2D20BD": _driver = RSR2_IVEPR_Helper.Create(); break;
					case "F9E53403-1BB8-4AE5-AD41-D93BA6EAB675": _driver = RSR2_IVMS_Helper.Create(); break;
					case "08E4A753-DDD4-4FB7-A809-9447068192B8": _driver = RSR2_IZMS_Helper.Create(); break;
					case "0F6B6AEE-4D7A-4E9D-9C16-0072CDC40932": _driver = RSR2_JokeyPump_Helper.Create(); break;
					case "CEF793CA-7E3E-446C-82DE-A032445B6CBA": _driver = RSR2_KDKR_Helper.Create(); break;
					case "CDEAC410-1B73-4C8B-BBE6-4D829E168A77": _driver = RSR2_KDKR_Part_Helper.Create(); break;
					case "13286BE1-D14D-479E-8F44-E98225340F7C": _driver = RSR2_KPP_Helper.Create(); break;
					case "A9FF1416-D5FE-4A66-835D-CBDA790D547E": _driver = RSR2_MAP2_Group_Helper.Create(); break;
					case "FE44E469-55FB-4079-A50D-A0E4C098F0AC": _driver = RSR2_MAP4_Group_Helper.Create(); break;
					case "42B3C448-2FDD-43D4-AEE0-F173CB8D6CF8": _driver = RSR2_MAP4_Helper.Create(); break;
					case "1582D8A4-4276-4AEF-BE8B-03C0023F1BFF": _driver = RSR2_MAV_1_Helper.Create(); break;
					case "8645D1C1-0D1F-4FDF-BB0F-A9C4B19039DB": _driver = RSR2_MAV_2_Group_Helper.Create(); break;
					case "BD678122-3965-4B9A-BD14-8266FA8DECB9": _driver = RSR2_MAV_4_Group_Helper.Create(); break;
					case "1BD3CDB3-7427-4FE8-9B56-22C14C9F5435": _driver = RSR2_MDU_Helper.Create(); break;
					case "2C149B68-FFE9-4680-B3CB-BE4CD37BF646": _driver = RSR2_MDU24_Helper.Create(); break;
					case "A0F70D76-A348-4ABA-A68E-531C6F6B1461": _driver = RSR2_MI_Helper.Create(); break;
					case "391D8F9A-0F86-4DF8-826E-B77E21B853B9": _driver = RSR2_MSP_Helper.Create(); break;
					case "E3BF33FA-8650-47F1-B182-162161CAF077": _driver = RSR2_MSV_Helper.Create(); break;
					case "7C329145-1619-4C28-8665-21054B2D95B4": _driver = RSR2_MTS_Helper.Create(); break;
					case "2ABAF6C0-6B9B-4658-8AB6-7FF15914B06F": _driver = RSR2_MVK2_Group_Helper.Create(); break;
					case "D3FD9DE2-D2E8-4DAC-B44E-82B202BE3534": _driver = RSR2_MVK4_Group_Helper.Create(); break;
					case "5EE43F54-5F4C-4412-8797-3D7F9A92D2E3": _driver = RSR2_MVK8_Group_Helper.Create(); break;
					case "3E55ACEF-D0D6-443A-A247-E9D5D116429A": _driver = RSR2_MVK8_Helper.Create(); break;
					case "0B1BD00D-680B-4A80-AC9A-659FD7F85BB4": _driver = RSR2_MVP_Helper.Create(); break;
					case "118A822D-25F0-429A-A1E8-3EFEB40900E0": _driver = RSR2_MVP_Part_Helper.Create(); break;
					case "9324C68B-3B66-4176-A31F-281B5380CA9F": _driver = RSR2_OMSP_Helper.Create(); break;
					case "8E339F21-E32E-4548-ADC3-3AB6C0D2768A": _driver = RSR2_OPKS_Helper.Create(); break;
					case "8A277079-341B-4933-BEB7-4E34B58199D7": _driver = RSR2_OPKZ_Helper.Create(); break;
					case "A8AC8A76-064B-4ED0-A071-37B4A15958A7": _driver = RSR2_OPS_Helper.Create(); break;
					case "7E03462F-D397-449C-A7B7-48ABED3579D1": _driver = RSR2_OPSZ_Group_Helper.Create(); break;
					case "24A6FC19-0428-43A9-8B1C-35B748BD202B": _driver = RSR2_OPZ_Helper.Create(); break;
					case "58C2A881-783F-4638-A27C-42257D5B31F9": _driver = RSR2_RM_1_Helper.Create(); break;
					case "A2959070-BB9D-45C0-8113-F9662A1CE7BF": _driver = RSR2_RM_2_Helper.Create(); break;
					case "E3001BBB-18DA-437D-AB73-56C701F070D4": _driver = RSR2_RM_4_Helper.Create(); break;
					case "4F9DFCDD-B98B-4D2B-BD7E-635BB5728DCE": _driver = RSR2_SCOPA_Helper.Create(); break;
					case "6656F587-16D7-48B0-ACC0-B4F24F79ED8A": _driver = RSR2_SCOPA_S_Helper.Create(); break;
					case "6AC0BEEE-19E7-4AAE-A107-6D52CF87EAD9": _driver = RSR2_SCOPA_SZ_Group_Helper.Create(); break;
					case "7DA4BCC5-8290-477D-9F0E-26C02E7BF61A": _driver = RSR2_SCOPA_Z_Helper.Create(); break;
					case "B33E2D92-E3C5-4309-8897-C9EF7C81E568": _driver = RSR2_Shuv_Helper.Create(); break;
					case "A50FFA41-B53E-4B3B-ADDF-CDBBA631FEB2": _driver = RSR2_SmokeDetector_Helper.Create(); break;
					case "79D5B336-8892-4D56-929C-1D95F0FF0992": _driver = RSR2_Valve_DU_Helper.Create(); break;
					case "21436E97-8B37-4B92-A4D6-D076C6D39D4D": _driver = RSR2_Valve_KV_Helper.Create(); break;
					case "38E9171D-A80B-4B6A-9C49-620D5B190976": _driver = RSR2_Valve_KVMV_Helper.Create(); break;
					case "58795922-F023-4A90-BCEC-ACDB3CD0725F": _driver = RSR2_ZOV_Helper.Create(); break;
					case "D34219D9-3B49-4B12-866C-F75CB2B93845": _driver = RSR2_BMPKR_Helper.Create(); break;
					case "5954D868-CAD7-47DE-AD13-87A49E07C5B7": _driver = RSR2_BMPK_Helper.Create(); break;
					case "33D7122B-0898-433A-BA1C-212231E5C211": _driver = RSR2_BMPKR_Part_Helper.Create(); break;
					case "D2DD5E51-DC72-4106-8054-78B136B10A18": _driver = RSR2_BMPP_Helper.Create(); break;
					case "F388F0E0-001E-4BAE-89DE-0B512A684324": _driver = RSR2_BMPUI_Helper.Create(); break;
					default: _driver = new GKDriver(); break;
				}
				this.SetStatusBitsAndControlsVisibilities();
			}
		}
		public void OnPropertyChanged([CallerMemberName] string propertyName = null)
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}

		public uint SerialNo { get; set; }

		//public List<GKDevice> subDevices = new List<GKDevice>();
		public string StrAddress { set; get; }
		public int Position { set; get; }

		public TreeViewItem GetTree()
        {
			TreeViewItem tvi = new TreeViewItem();
			StackPanel sp = new StackPanel();
			sp.Orientation = Orientation.Horizontal;
			Image i1 = new Image();
			i1.Source = new BitmapImage(new Uri(""+ this.Driver.ImageSource.Replace("GKModule/", ""), UriKind.Relative));// this.Driver.ImageSource.Replace("GKModule/","")));
			i1.Width = 16;
			i1.Height = 16;
			TextBlock t0 = new TextBlock();
			t0.Text = "[" + this.IntAddress + "]";
			t0.Width = 30;
			t0.HorizontalAlignment = HorizontalAlignment.Left;
			t0.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t1 = new TextBlock();
			t1.Text = this.StrAddress;
			t1.Width = 30;
			t1.HorizontalAlignment = HorizontalAlignment.Left;
			t1.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t2 = new TextBlock();
			t2.Text = this.Driver.ShortName;
			t2.Width = 90;
			t2.Margin = new Thickness(15, 0, 15, 0);
			t2.HorizontalAlignment = HorizontalAlignment.Left;
			t2.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t3 = new TextBlock();
			t3.Text = this.SerialNo.ToString();
			t3.Width = 80;
			t3.HorizontalAlignment = HorizontalAlignment.Left;
			t3.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t4 = new TextBlock();
			t4.Text = this.Driver.Name;
			t4.Width = 350;
			t4.HorizontalAlignment = HorizontalAlignment.Left;
			t4.VerticalAlignment = VerticalAlignment.Center;
			sp.Children.Add(t0);
			sp.Children.Add(t1);
			sp.Children.Add(i1);
			sp.Children.Add(t2);
			sp.Children.Add(t3);
			sp.Children.Add(t4);
			tvi.Header = sp;
			tvi.Tag = this;
			if (this.Devices != null)
            {
				foreach(GKDevice d in this.Devices)
					tvi.Items.Add(d.GetSubTree());
            }
			return tvi;
        }
		public TreeViewItem GetSubTree()
		{
			TreeViewItem tvi = new TreeViewItem();
			StackPanel sp = new StackPanel();
			sp.Margin = new Thickness(10, 0, 10, 0);
			sp.Orientation = Orientation.Horizontal;
			Image i1 = new Image();
			i1.Source = new BitmapImage(new Uri("" + this.Driver.ImageSource.Replace("GKModule/", ""), UriKind.Relative));// this.Driver.ImageSource.Replace("GKModule/","")));
			i1.Width = 16;
			i1.Height = 16;
			TextBlock t0 = new TextBlock();
			t0.Text = "[" + this.IntAddress + "]";
			t0.Width = 30;
			t0.HorizontalAlignment = HorizontalAlignment.Left;
			t0.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t1 = new TextBlock();
			t1.Text = this.StrAddress;
			t1.Width = 30;
			t1.HorizontalAlignment = HorizontalAlignment.Left;
			t1.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t2 = new TextBlock();
			t2.Text = this.Driver.ShortName;
			t2.Width = 90;
			t2.Margin = new Thickness(15, 0, 15, 0);
			t2.HorizontalAlignment = HorizontalAlignment.Left;
			t2.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t3 = new TextBlock();
			t3.Text = "";//this.SerialNo.ToString();
			t3.Width = 80;
			t3.HorizontalAlignment = HorizontalAlignment.Left;
			t3.VerticalAlignment = VerticalAlignment.Center;
			TextBlock t4 = new TextBlock();
			t4.Text = this.Driver.Name;
			t4.Width = 350;
			t4.HorizontalAlignment = HorizontalAlignment.Left;
			t4.VerticalAlignment = VerticalAlignment.Center;
			sp.Children.Add(t0);
			sp.Children.Add(i1);
			sp.Children.Add(t2);
			sp.Children.Add(t3);
			sp.Children.Add(t4);
			tvi.Header = sp;
			tvi.Tag = this;
			if (this.Devices != null)
			{
				foreach (GKDevice d in this.Devices)
					tvi.Items.Add(d.GetTree());
			}
			return tvi;
		}
		public XmlNode ToXML(XmlDocument xDoc)
        {
			XmlNode xNode = xDoc.CreateNode(XmlNodeType.Element, "DEVICE", "");
			XmlNode xAttr = xDoc.CreateNode(XmlNodeType.Attribute, "SNum", "");
			xAttr.Value = this.SerialNo.ToString();
			xNode.Attributes.SetNamedItem(xAttr);
			xAttr = xDoc.CreateNode(XmlNodeType.Attribute, "StrAddr", "");
			xAttr.Value = this.StrAddress;
			xNode.Attributes.SetNamedItem(xAttr);
			xAttr = xDoc.CreateNode(XmlNodeType.Attribute, "IntAddr", "");
			xAttr.Value = this.IntAddress.ToString();
			xNode.Attributes.SetNamedItem(xAttr);
			xAttr = xDoc.CreateNode(XmlNodeType.Attribute, "DrvType", "");
			xAttr.Value = this.DriverType.ToString();
			xNode.Attributes.SetNamedItem(xAttr);
			if (this.Devices != null)
			{
				foreach (GKDevice dv in this.Devices)
				{
					xNode.AppendChild(dv.ToXML(xDoc));
				}
			}

			return xNode;
        }
		public void FromXML(XmlNode xNode)
        {
			foreach(XmlAttribute xAttr in xNode.Attributes)
            {
                switch (xAttr.Name)
                {
					case "SNum": this.SerialNo = uint.Parse(xAttr.Value); break;
					case "StrAddr": this.StrAddress = xAttr.Value; break;
					case "IntAddr": this.IntAddress = int.Parse(xAttr.Value); break;
					case "DrvType": //int dtp = int.Parse(xAttr.Value);
						this.Driver = DriversRepository1.Drivers.FirstOrDefault(x => x.DriverType.ToString() == xAttr.Value);
						break;
                }
            }
			this.Devices = new List<GKDevice>();
			foreach(XmlNode xNd in xNode.ChildNodes)
            {
				GKDevice d = new GKDevice();
				d.FromXML(xNd);
				this.Devices.Add(d);
            }
        }

		void SetStatusBitsAndControlsVisibilities()
		{
			#region
			// (0) Включить автоматику
			// (1) В ручной режим
			// (2) Отключить
			// (3) Снять тест
			// (4) Сброс
			// (7) Остановить (руч. режим)
			// (8) Включить (авт.включена)
			// (9) Выключить (авт.включена)
			// (10) Вкл.немедленно (авт.вкл.)
			// (11) Выкл.немедленно (авт.вкл.)
			// (12) Вкл. (ручное управление)
			// (13) Выкл. (ручное управление)
			// (14) Вкл.немедленно (руч.упр.)
			// (15) Откл.немедленно (руч.упр.)
			CmdNames = new List<string>();
			CmdNames.Add("(0) Включить автоматику");
			CmdNames.Add("(1) В ручной режим");
			CmdNames.Add("(2) Отключить");
			CmdNames.Add("(3) Снять тест");
			CmdNames.Add("(4) Сброс");
			CmdNames.Add("");
			CmdNames.Add("");
			CmdNames.Add("(7) Остановить (руч. режим)");
			CmdNames.Add("(8) Включить (авт.включена)");
			CmdNames.Add("(9) Выключить (авт.включена)");
			CmdNames.Add("(10) Вкл.немедленно (авт.вкл.)");
			CmdNames.Add("(11) Выкл.немедленно (авт.вкл.)");
			CmdNames.Add("(12) Вкл. (ручное управление)");
			CmdNames.Add("(13) Выкл. (ручное управление)");
			CmdNames.Add("(14) Вкл.немедленно (руч.упр.)");
			CmdNames.Add("(15) Откл.немедленно (руч.упр.)");
			#endregion
			switch (this.Driver.DriverTypeNo)
			{
				case 0x16:
					this.StateWord1.Add(3, "Пожар2");
					this.StateWord1.Add(4, "Тест");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xDD:
					this.StateWord1.Add(2, "Пожар1");
					this.StateWord1.Add(4, "Тест");

					this.StateWord2.Add(0, "Сработка по дыму");
					this.StateWord2.Add(3, "Запыленность");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xDF:
					this.StateWord1.Add(2, "Пожар1");
					this.StateWord1.Add(4, "Тест");

					this.StateWord2.Add(0, "Сработка по дыму");
					this.StateWord2.Add(1, "Сработка по температуре");
					this.StateWord2.Add(2, "Сработка по градиенту температуры");
					this.StateWord2.Add(3, "Запыленность");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xDE:
					this.StateWord1.Add(2, "Пожар1");
					this.StateWord1.Add(4, "Тест");

					this.StateWord2.Add(1, "Сработка по температуре");
					this.StateWord2.Add(2, "Сработка по градиенту температуры");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xD8:
					this.StateWord1.Add(3, "Пожар2");
					this.StateWord1.Add(4, "Тест");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					break;
				case 0xE3:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xE6:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xDB:
					this.StateWord1.Add(2, "Пожар1");
					this.StateWord1.Add(3, "Пожар2");
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");

					this.StateWord2.Add(0, "КЗ");
					this.StateWord2.Add(1, "ОБР");
					this.StateWord2.Add(2, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xE2:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.StateWord2.Add(0, "Питание ниже нормы");
					this.StateWord2.Add(1, "Обрыв выхода");
					this.StateWord2.Add(2, "КЗ выхода");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0x25:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(8, "АЛС1");
					this.StateWord1.Add(9, "АЛС2");

					this.StateWord2.Add(0, "КЗ  АЛС1");
					this.StateWord2.Add(1, "КЗ  АЛС2");
					this.StateWord2.Add(2, "Питание низкое");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xDA:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.StateWord2.Add(0, "Питание ниже нормы");
					this.StateWord2.Add(1, "Обрыв выхода");
					this.StateWord2.Add(2, "КЗ выхода");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xDC:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.StateWord2.Add(0, "Контакт реле 1 не переключается (таймаут 10 млс)");
					this.StateWord2.Add(1, "Контакт реле 2 не переключается (таймаут 10 млс)");
					this.StateWord2.Add(2, "Истекло время включения");
					this.StateWord2.Add(3, "Истекло время выключения");
					this.StateWord2.Add(4, "КЗ концевик ОТКРЫТО");
					this.StateWord2.Add(5, "ОБР концевик ОТКРЫТО");
					this.StateWord2.Add(6, "КЗ концевик ЗАКРЫТО");
					this.StateWord2.Add(7, "ОБР концевик ЗАКРЫТО");
					this.StateWord2.Add(8, "КЗ внешняя кнопка НОРМА");
					this.StateWord2.Add(9, "ОБР внешняя кнопка НОРМА");
					this.StateWord2.Add(10, "КЗ внешняя кнопка ЗАЩИТА");
					this.StateWord2.Add(11, "ОБР внешняя кнопка ЗАЩИТА");
					this.StateWord2.Add(12, "ОБР цепи 1 двигателя (ЗАЩИТА)");
					this.StateWord2.Add(13, "ОБР цепи 2 двигателя (НОРМА)");
					this.StateWord2.Add(14, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(7, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xE1:
					this.StateWord1.Add(2, "Сработка1");
					this.StateWord1.Add(3, "Сработка2");
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.StateWord2.Add(0, "Питание ниже нормы");
					this.StateWord2.Add(1, "Обрыв");
					this.StateWord2.Add(2, "КЗ");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xE4:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					break;
				case 0xEC:
				case 0xEB:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xD4:
					this.StateWord1.Add(2, "Пожар1");
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");

					this.StateWord2.Add(0, "КЗ  АЛС1");
					this.StateWord2.Add(2, "КЗ  АЛС2");
					this.StateWord2.Add(3, "КЗ  АЛС3");
					this.StateWord2.Add(4, "КЗ  АЛС4");
					this.StateWord2.Add(5, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xE7:
					this.StateWord1.Add(1, "Сработка (*код#)");
					this.StateWord1.Add(2, "Сработка (*1*код#)");
					this.StateWord1.Add(3, "Сработка (*2*код#)");
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");
					this.StateWord1.Add(9, "Включение");
					this.StateWord1.Add(10, "Отключение");

					this.StateWord2.Add(0, "Контакт реле не переключается");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(7, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					break;
				case 0x10:
					this.StateWord1.Add(2, "Сработка");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0x11:
					this.StateWord1.Add(2, "Сработка");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");

					this.StateWord2.Add(0, "Неисправность НЧ");
					this.StateWord2.Add(1, "Неисправность ВЧ");
					this.StateWord2.Add(2, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xF8:
					this.StateWord1.Add(5, "Неисправность");

					this.StateWord2.Add(0, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					this.CMDControls.Add(7, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					break;
				case 0xF9:
					break;
				case 0xFA:
					break;
				case 0xFB:
					break;
				case 0xFC:
					break;
				case 0xEE:
					this.StateWord1.Add(2, "Сработка");
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");
					this.StateWord1.Add(7, "Включено");
					this.StateWord1.Add(8, "Отключено");

					this.StateWord2.Add(0, "Питание");
					this.StateWord2.Add(1, "Вскрытие");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					break;
				case 0xD7:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(5, "Неисправность");

					this.StateWord2.Add(0, "КЗ  ШС");
					this.StateWord2.Add(1, "ОБРЫВ ШС");
					this.StateWord2.Add(2, "Питание плохое");
					this.StateWord2.Add(3, "Вскрытие корпуса");

					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xF0:
					this.StateWord1.Add(4, "Тест");
					this.StateWord1.Add(2, "Пожар1");

					this.CMDControls.Add(3, "");
					break;
				//-------------------------------------------------------------------------------------------------------------
				case 0xD0:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					this.CMDControls.Add(7, "");
					break;
				case 0xCE:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xCA:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xC5:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(4, "");
					break;
				case 0xD9:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xE0:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(1, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(11, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					this.CMDControls.Add(15, "");
					break;
				case 0xE5:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					break;
				case 0x15:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xD6:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					this.CMDControls.Add(8, "");
					this.CMDControls.Add(9, "");
					this.CMDControls.Add(10, "");
					this.CMDControls.Add(12, "");
					this.CMDControls.Add(13, "");
					this.CMDControls.Add(14, "");
					break;
				case 0xD5:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xD1:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
				case 0xD2:
					this.CMDControls.Add(0, "");
					this.CMDControls.Add(2, "");
					this.CMDControls.Add(3, "");
					break;
			}
		}

	}
}
