﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GlobalCF
{
	public class GKDriverProperty
	{
		public GKDriverProperty()
		{
			Parameters = new List<GKDriverPropertyParameter>();
			IsAUParameter = true;
			Mask = 0;
		}

		public byte No { get; set; }
		public bool IsReadOnly { get; set; }
		public bool IsAUParameter { get; set; }
		public string Name { get; set; }
		public string Caption { get; set; }
		public string ToolTip { get; set; }
		public ushort Default { get; set; }
		public string StringDefault { get; set; }
		public bool IsHieghByte { get; set; }
		public bool IsLowByte { get; set; }
		public short Mask { get; set; }
		public List<GKDriverPropertyParameter> Parameters { get; set; }
		public GKDriverPropertyTypeEnum DriverPropertyType { get; set; }
		public ushort Min { get; set; }
		public double DisplayMin
		{
			get
			{
				if (this.Multiplier != 0)
					return (double)this.Min / this.Multiplier;
				else
					return (double)this.Min;
			}
		}
		public ushort Max { get; set; }
		public double DisplayMax
		{
			get
			{
				if (this.Multiplier != 0)
					return (double)this.Max / this.Multiplier;
				else
					return (double)this.Max;
			}
		}
		public double Multiplier { get; set; }
		public bool CanNotEdit { get; set; }
		public string DisplayValue
		{
			set
			{
				if (this.Multiplier != 0)
					this.Default = (ushort)(double.Parse(value) * this.Multiplier);
				else
					this.Default = (ushort)(double.Parse(value));
			}
			get
			{
				if ((this.DriverPropertyType == GKDriverPropertyTypeEnum.BoolType) || (this.DriverPropertyType == GKDriverPropertyTypeEnum.EnumType))
				{
					foreach (GKDriverPropertyParameter p in this.Parameters)
					{
						if (p.Value == this.Default)
							return this.Parameters[this.Parameters.IndexOf(p)].Name;
					}
					return "";
				}
				else
				{
					if (this.Multiplier != 0)
						return ((double)this.Default / this.Multiplier).ToString();
					else
						return ((double)this.Default).ToString();
				}
			}
		}
	}

	public class GKDriverPropertyParameter
	{
		public string Name { get; set; }
		public ushort Value { get; set; }
	}

	public enum GKDriverPropertyTypeEnum
	{
		EnumType,
		StringType,
		IntType,
		BoolType,
		NegativeShortType
	}


}
