﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.ComponentModel;
using Newtonsoft.Json;
using System.Globalization;
using System.Text;

namespace GlobalCF
{
	public static class SendManager
	{
		public static string ipAddress = "192.168.8.106";
		public static int port = 1025;
		public static readonly string ConnectionError = "Устройство недоступно или IP-адрес компьютера отсутствует в списке разрешенных адресов прибора";
		//static List<SendClient> SendClients = new List<SendClient>();
		public static List<DeviceGroup> deviceGroups = new List<DeviceGroup>();

		public static SendResult Send(byte whom, ushort length, byte command, ushort inputLenght, List<byte> data = null, bool hasAnswer = true, bool sleepInsteadOfRecieve = false, int receiveTimeout = 3500, bool checkReserve = true, bool checkHash = true, bool getEcho = false)
		{
			/*if ((device == null) || (device.Driver == null))
			{
				return new SendResult("Неизвестное устройство");
			}*/

			/*if (device.IsInnerKau)
				checkReserve = false;*/

			//whom = 4;
			/*switch (device.DriverType)
			{
				case GKDriverType.GK:
					whom = 2;
					break;

				case GKDriverType.RSR2_KAU:
				case GKDriverType.GKMirror:
					whom = 4;
					var modeProperty = device.Properties.FirstOrDefault(x => x.Name == "Mode");
					if (modeProperty != null)
					{
						switch (modeProperty.Value)
						{
							case 0:
								whom = 4;
								break;

							case 1:
								whom = 5;
								break;

							default:
								throw new Exception("Неизвестный тип линии");
						}
					}
					break;

				default:
					throw new Exception("Команду можно отправлять только в ГК, в МОПС или в ТПУ");
			}*/
			SendResult resultBytes = null;
			//if (WatcherManager.Watchers != null && WatcherManager.Watchers.Count > 0)
			{
				/*var baseWatcher = WatcherManager.Watchers.FirstOrDefault(x => x.GkDatabase.RootDevice == device.GKParent);
				var watchers = new List<Watcher> { baseWatcher };
				if (device.GKParent.HasReserve && checkReserve)
				{
					var reservedWatcher = WatcherManager.Watchers.FirstOrDefault(x => x.GkDatabase.RootDevice == device.GKParent.ReserveGk);
					if (reservedWatcher != null) watchers.Add(reservedWatcher);
				}*/

				//foreach (var watcher in watchers.OrderBy(x => x.IsPingFailure))
				{
					var bytes = new List<byte>();
					/*if (whom == 4 && watcher.FirstLostKauNo >= 0 && watcher.LastLostKauNo >= 0 && !device.IsInnerKau)
					{
						if (device.IntAddress >= watcher.LastLostKauNo)
							whom = 6;
					}*/
					bytes.Add(whom);
					/*if (whom == 6)
						bytes.Add((byte)(256 - 1 - (watcher.KausCount - device.IntAddress)));
					else
						bytes.Add((byte)device.IntAddress);*/
					bytes.Add((byte)1);

					bytes.AddRange(ToBytes(length));
					bytes.Add(command);
					if (data != null)
						bytes.AddRange(data);
					if (string.IsNullOrEmpty(ipAddress))
					{
						return new SendResult("Не задан адрес ГК");
					}
					/*var sendClient = SendClients.FirstOrDefault(x => x.IpAddress == ipAddress);
					if (sendClient == null || DateTime.Now.Subtract(sendClient.ExecuteTime).Seconds > 10)
					{
						SendClients.Remove(sendClient);
						sendClient = new SendClient(ipAddress);
						SendClients.Add(sendClient);
					}*/
					resultBytes = SendBytes(ipAddress, port, bytes, inputLenght, hasAnswer, sleepInsteadOfRecieve, receiveTimeout, getEcho: getEcho);
					//sendClient.ExecuteTime = DateTime.Now;
					if (!resultBytes.HasError)
					{
						//break;
					}
				}
			}
			return resultBytes;
		}

		public static SendResult SendBytes(string stringIPAddress, int port, List<byte> bytes, ushort inputLenght, bool hasAnswer = true, bool sleepInsteadOfRecieve = false, int receiveTimeout = 10000, bool getEcho = false)
		{
			/*AddLog("   Send " + BitConverter.ToString(bytes.ToArray()));
			var requestLogItem = new GKLogItem(GKLogItemType.Request, bytes.ToArray(), stringIPAddress);*/

			var result = IPAddress.TryParse(stringIPAddress, out var ipAddress);
			if (!result)
			{
				return new SendResult("Неверный формат IP адреса");
			}
			var endPoint = new IPEndPoint(ipAddress, port);
			var udpClient = new UdpClient();
			udpClient.Client.ReceiveTimeout = receiveTimeout;
			udpClient.Client.SendTimeout = 4000;

			try
			{
				var sendTask = udpClient.SendAsync(bytes.ToArray(), bytes.Count, endPoint);
				if (!sendTask.Wait(receiveTimeout))
					throw new TimeoutException();
				if (sendTask.Result != bytes.Count)
				{
					return new SendResult("Не все данные удалось отправить");
				}
			}
			catch
			{
				OnConnectionLost();
				udpClient.Dispose();
				return new SendResult("Ошибка открытия сокета");
			}
			if (hasAnswer == false)
			{
				udpClient.Dispose();
				/*GKLoggerManager.AddLog(stringIPAddress, port, requestLogItem);
				return new SendResult(new List<byte>());*/
			}
			var recievedBytes = new List<byte>();
			try
			{
				if (sleepInsteadOfRecieve)
				{
					//GKLoggerManager.AddLog(stringIPAddress, port, requestLogItem);
					//Thread.Sleep(10000);
					return new SendResult(new List<byte>());
				}
				var receiveTask = udpClient.ReceiveAsync();
				if (!receiveTask.Wait(receiveTimeout))
				{
					//GKLoggerManager.AddLog(stringIPAddress, port, requestLogItem);
					throw new TimeoutException();
				}
				recievedBytes = receiveTask.Result.Buffer.ToList();
			}
			catch
			{
				OnConnectionLost();
				udpClient.Dispose();
				return new SendResult(ConnectionError);
			}
			udpClient.Dispose();
			//GKLoggerManager.AddLog(stringIPAddress, port, requestLogItem, new GKLogItem(GKLogItemType.Reply, recievedBytes.ToArray(), stringIPAddress));
			if (recievedBytes[0] != bytes[0])
			{
				return new SendResult("Не совпадает байт 'Кому'");
			}
			if (recievedBytes[1] != bytes[1])
			{
				return new SendResult("Не совпадает байт 'Адрес'");
			}
			if (recievedBytes[4] != bytes[4])
			{
				return new SendResult("Не совпадает байт 'Команда'");
			}

			var recievedInputLenght = (ushort)(recievedBytes[2] + 256 * recievedBytes[3]);
			if (inputLenght != ushort.MaxValue)
			{
				if (inputLenght != recievedInputLenght)
				{
					//return new SendResult("Не совпадает байт 'Длина'");
				}
			}
			return new SendResult(getEcho ? recievedBytes : recievedBytes.Skip(5).ToList());
		}

		public static List<byte> ToBytes(ushort shortValue)
		{
			return BitConverter.GetBytes(shortValue).ToList();
		}

		public static event Action ConnectionLost;
		static void OnConnectionLost()
		{
			ConnectionLost?.Invoke();
		}

		static void ParseSoftwareVersion(List<byte> bytes, out byte SoftwareVersion, out bool IsTechnical)
		{
			byte softwareVersion = bytes[0];
			bool isTechnical = softwareVersion > 127;
			softwareVersion = (byte)(softwareVersion << 1);
			softwareVersion = (byte)(softwareVersion >> 1);
			SoftwareVersion = softwareVersion;
			IsTechnical = isTechnical;
			//return (softwareVersion, isTechnical);
		}


		public static string ReadDateTime(byte whom)
		{
			var sendResult = SendManager.Send(whom, 0, 4, 6);
			if (sendResult.HasError)
			{
				return "Устройство недоступно";
			}
			var Day = sendResult.Bytes[0];
			var Month = sendResult.Bytes[1];
			var Year = sendResult.Bytes[2];
			var Hour = sendResult.Bytes[3];
			var Minute = sendResult.Bytes[4];
			var Second = sendResult.Bytes[5];
			var stringTime = Day.ToString() + "/" + Month.ToString() + "/" + Year.ToString() + " " + Hour.ToString() + ":" + Minute.ToString() + ":" + Second.ToString();
			return stringTime;
		}
		public static bool WriteDateTime(byte whom)
		{
			var dateTime = DateTime.Now;
			var bytes = new List<byte>();
			bytes.Add((byte)dateTime.Day);
			bytes.Add((byte)dateTime.Month);
			bytes.Add((byte)(dateTime.Year - 2000));
			bytes.Add((byte)dateTime.Hour);
			bytes.Add((byte)dateTime.Minute);
			bytes.Add((byte)dateTime.Second);
			var sendResult = SendManager.Send(whom, 6, 5, 0, bytes, checkReserve: false);
			return !sendResult.HasError;
		}
		public static SendResult Ping(byte whom)
		{
			bool checkHash = true;
			var sendResult = SendManager.Send(whom, 0, 1, 1, checkReserve: false, checkHash: checkHash);
			return sendResult;
		}
		public static string GetDeviceInfo(byte whom)
		{
			try
			{
				var stringBuilder = new StringBuilder();
				var result1 = Ping(whom);
				if (result1.HasError)
				{
					if (result1.HasError)
					{
						return null;
					}
				}


				bool IsTechnical;
				byte SoftwareVersion;
				ParseSoftwareVersion(result1.Bytes, out SoftwareVersion, out IsTechnical);
				stringBuilder.Append(IsTechnical ? "Режим: Технологический" : "Режим: Рабочий");
				stringBuilder.Append("  Версия ПО: " + SoftwareVersion);

				/*var result2 = SendManager.Send(whom, 0, 2, 8, checkReserve: false, checkHash: false);
				if (result2.HasError)
					if (result1.HasError)
						return null;

				var serialNo = (uint)BytesHelper.SubstructInt(result2.Bytes, 0);
				stringBuilder.Append("  Серийный номер: " + serialNo.ToString());

				var hardwareVervion = (uint)BytesHelper.SubstructInt(result2.Bytes, 4);
				stringBuilder.Append("  Аппаратный номер: " + hardwareVervion.ToString());*/

				return stringBuilder.ToString();
			}
			catch (Exception e)
			{
				//Logger.Error(e, "DeviceBytesHelper.ShowInfoCommand");
				return "Внутренняя ошибка при выполнении операции";
			}
		}
		public static uint GetHardwareVersion(byte whom)
		{
			var result = SendManager.Send(whom, 0, 2, 8, checkReserve: false, checkHash: false);
			return (uint)BytesHelper.SubstructInt(result.Bytes, 4);
		}
		public static bool GoToTechnologicalRegime(byte whom)
		{
			SendManager.Send(whom, 0, 14, 0, null, false, checkReserve: false, checkHash: false);
			Thread.Sleep(TimeSpan.FromSeconds(4));
			for (int i = 0; i < 5; i++)
			{
				if (IsInTechnologicalRegime(whom))
				{
					return true;
				}
				Thread.Sleep(TimeSpan.FromSeconds(1));
			}
			return false;
		}
		public static bool IsInTechnologicalRegime(byte whom)
		{
			/*var sendResult = Ping(whom);
			if (!sendResult.HasError)
			{
				if (sendResult.Bytes.Count > 0)
				{
					var version = sendResult.Bytes[0];
					if (version > 127)
					{
						return true;
					}
				}
			}*/
			return true;
		}
		public static bool IsInWorkingRegime(byte whom)
		{
			/*var sendResult = Ping(whom);
			if (!sendResult.HasError)
			{
				if (sendResult.Bytes.Count > 0)
				{
					var version = sendResult.Bytes[0];
					if (version <= 127)
					{
						return true;
					}
				}
			}*/
			return true;
		}
		public static bool GetPollingStatus()
        {
			var result = SendManager.Send(4, 0, 0x23, 8, checkReserve: false, checkHash: false);
			if (result.Bytes[result.Bytes.Count - 1] == 1)
				return true;
			else
				return false;
		}
		public static bool SendBroadcast_(byte SendType)
		{
			List<byte> data = new List<byte>();
			data.Add(SendType);
			var result = SendManager.Send(4, 0, 0x24, 8, data, sleepInsteadOfRecieve: true, checkReserve: false, checkHash: false);
			return false;
		}
		public static bool SendBroadcast(byte als, byte SendType)
		{
			List<byte> data = new  List<byte>();

			data.Add(SendType);
			data.Add(als);
			
			var result = SendManager.Send(4, 0, 0x24, 8, data, sleepInsteadOfRecieve: true, checkReserve: false, checkHash: false);
			return false;
		}

		public static bool GoToWorkingRegime(byte whom, bool waitUntillStart = true, int tryNo = 0, bool checkReserve = true)
		{
			var title = "Переход в рабочий режим" + (tryNo > 0 ? " Попытка " + (tryNo + 1) : "");
			{
				SendManager.Send(whom, 0, 11, 0, null, false, checkReserve: checkReserve);
				Thread.Sleep(TimeSpan.FromSeconds(4));
				for (int i = 0; i < 15; i++)
				{
					if (IsInWorkingRegime(whom))
					{
						return true;
					}
					Thread.Sleep(TimeSpan.FromSeconds(1));
				}
				return false;
			}
		}
		public static int GetDescriptorsCount(byte whom)
		{
			var startaddress = 0x078000;
			var result = 0;
			string Error = "";
			while (true)
			{
				var startAddressBytes = BitConverter.GetBytes(startaddress);
				startaddress += 256;

				var data = new List<byte>(startAddressBytes);
				var sendResult = SendManager.Send(whom, 4, 31, 256, data);
				if (sendResult.Bytes.Count != 256)
				{
					Error = "Не удалось распознать дескриптор";
					return 0;
				}
				for (int i = 0; i < 256 / 4; i++)
				{
					if (BytesHelper.SubstructInt(sendResult.Bytes, i * 4) == -1)
					{
						return result;
					}
					result++;
				}
			}
		}

		public static bool ScanDevices(byte Cmd, List<GKDevice> devices)
        {
			int prevAddr = 0;
			uint prevSerialNo = 0;
			int SubAddressId = 0;
			var bytes = new List<byte>();
			bytes.Add(Cmd);
			var result2 = new SendResult("");
			result2 = SendManager.Send(4, 3, 0x86, 6, bytes, true, false, 3000, checkHash: false);
			if (!result2.HasError)
			{
				if (result2.Bytes.Count > 0)
				{
					Encoding enc8 = Encoding.UTF8;
					string devListjson = enc8.GetString(result2.Bytes.ToArray());
					//@"[{'ser_no': 7718426, 'type': 222, 'addr': 1}, {'ser_no': 7717231, 'type': 222, 'addr': 2}, {'ser_no': 9016473, 'type': 235, 'addr': 3}, {'ser_no': 9016473, 'type': 236, 'addr': 4}, {'ser_no': 7700656, 'type': 218, 'addr': 5}, {'ser_no': 7700656, 'type': 218, 'addr': 6}, {'ser_no': 7700656, 'type': 218, 'addr': 7}, {'ser_no': 7700656, 'type': 218, 'addr': 8}, {'ser_no': 8858545, 'type': 37, 'addr': 9}, {'ser_no': 1253001, 'type': 216, 'addr': 10}, {'ser_no': 1256350, 'type': 221, 'addr': 11}, {'ser_no': 7718434, 'type': 222, 'addr': 12}, {'ser_no': 9016466, 'type': 235, 'addr': 13}, {'ser_no': 9016466, 'type': 236, 'addr': 14}, {'ser_no': 7717954, 'type': 222, 'addr': 15}, {'ser_no': 3255520, 'type': 218, 'addr': 16}, {'ser_no': 3255520, 'type': 218, 'addr': 17}, {'ser_no': 3255520, 'type': 218, 'addr': 18}, {'ser_no': 3255520, 'type': 218, 'addr': 19}, {'ser_no': 8858568, 'type': 37, 'addr': 20}, {'ser_no': 1214063, 'type': 216, 'addr': 21}, {'ser_no': 1245755, 'type': 221, 'addr': 22}, {'ser_no': 1256369, 'type': 221, 'addr': 23}, {'ser_no': 9016469, 'type': 235, 'addr': 24}, {'ser_no': 9016469, 'type': 236, 'addr': 25}, {'ser_no': 1245767, 'type': 221, 'addr': 26}, {'ser_no': 7718426, 'type': 222, 'addr': 1}, {'ser_no': 7717231, 'type': 222, 'addr': 2}, {'ser_no': 9016473, 'type': 235, 'addr': 3}, {'ser_no': 9016473, 'type': 236, 'addr': 4}, {'ser_no': 7700656, 'type': 218, 'addr': 5}, {'ser_no': 7700656, 'type': 218, 'addr': 6}, {'ser_no': 7700656, 'type': 218, 'addr': 7}, {'ser_no': 7700656, 'type': 218, 'addr': 8}, {'ser_no': 8858545, 'type': 37, 'addr': 9}, {'ser_no': 1253001, 'type': 216, 'addr': 10}, {'ser_no': 1256350, 'type': 221, 'addr': 11}, {'ser_no': 7718434, 'type': 222, 'addr': 12}, {'ser_no': 9016466, 'type': 235, 'addr': 13}, {'ser_no': 9016466, 'type': 236, 'addr': 14}, {'ser_no': 7717954, 'type': 222, 'addr': 15}, {'ser_no': 3255520, 'type': 218, 'addr': 16}, {'ser_no': 3255520, 'type': 218, 'addr': 17}, {'ser_no': 3255520, 'type': 218, 'addr': 18}, {'ser_no': 3255520, 'type': 218, 'addr': 19}, {'ser_no': 8858568, 'type': 37, 'addr': 20}, {'ser_no': 1214063, 'type': 216, 'addr': 21}, {'ser_no': 1245755, 'type': 221, 'addr': 22}, {'ser_no': 1256369, 'type': 221, 'addr': 23}, {'ser_no': 9016469, 'type': 235, 'addr': 24}, {'ser_no': 9016469, 'type': 236, 'addr': 25}, {'ser_no': 1245767, 'type': 221, 'addr': 26}]";
					//enc8.GetString(result2.Bytes.ToArray());

					devListjson = "{\"devices\":" + devListjson + "}";

					lRoot myDeserializedClass = JsonConvert.DeserializeObject<lRoot>(devListjson);
					int idx = 1;
					/*if ((Cmd == 2) || (Cmd == 4))  //Переворачиваем список
					{
						myDeserializedClass.devices.Reverse();
					}*/
					GKDevice parentDvc = new GKDevice();
					foreach (lDevice d in myDeserializedClass.devices) {
						var driver = DriversRepository1.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)d.type);//GKManager.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)driverTypeNo);
						if (driver != null)
						{
							var device = new GKDevice();
							device.Driver = driver;
							device.DriverUID = driver.UID;
							device.IntAddress = (byte)d.addr;
							device.SerialNo = (uint)d.ser_no;
							if (d.ser_no == prevSerialNo)
							{
								SubAddressId++;
								device.StrAddress = "";//prevAddr.ToString() + "." + SubAddressId;
								device.IntAddress = (byte)d.addr;
								if (parentDvc.Devices == null)
									parentDvc.Devices = new List<GKDevice>();
								parentDvc.Devices.Add(device);
							}
							else
                            {
								parentDvc = device;
								device.StrAddress = "" + idx++;//device.IntAddress.ToString();
								SubAddressId = 0;
								prevAddr = device.IntAddress;
								devices.Add(device);
							}
							prevSerialNo = (uint)d.ser_no;


							var deviceGroup = deviceGroups.FirstOrDefault(x => x.SerialNo == d.ser_no);
							if (deviceGroup == null || d.ser_no == 0 ||
						 (driver.DriverType != GKDriverType.RSR2_AM_1
						 && driver.DriverType != GKDriverType.RSR2_ABTK
						 && driver.DriverType != GKDriverType.RSR2_MAV_1
						 && driver.DriverType != GKDriverType.RSR2_MAP4
						 && driver.DriverType != GKDriverType.RSR2_MVK8
						 && driver.DriverType != GKDriverType.RSR2_RM_1
						 && driver.DriverType != GKDriverType.RSR2_OPKZ
						 && driver.DriverType != GKDriverType.RSR2_KDKR
						 && driver.DriverType != GKDriverType.KD_KDZ
						 && driver.DriverType != GKDriverType.KD_KDK
						 && driver.DriverType != GKDriverType.KD_KDKV
						 && driver.DriverType != GKDriverType.KD_KDTD
						 && driver.DriverType != GKDriverType.RSR2_BMPK
						 && driver.DriverType != GKDriverType.RSR2_BMPKR_Part
						 && driver.DriverType != GKDriverType.RSR2_BMPP
						 && driver.DriverType != GKDriverType.RSR2_BMPUI
						 && driver.DriverType != GKDriverType.RSR2_ABShS))
							{
								deviceGroup = new DeviceGroup();
								deviceGroup.SerialNo = d.ser_no;
								deviceGroups.Add(deviceGroup);
							}
							deviceGroup.Devices.Add(device);
						}
					}
				}
			}
			else
			{
				return true;
			}
			return true;
		}
		public static bool GetDevices(byte Cmd, List<GKDevice> devices)
		{
			int prevAddr = 0;
			uint prevSerialNo = 0;
			int SubAddressId = 0;
			var bytes = new List<byte>();
			bytes.Add(Cmd);
			var result2 = new SendResult("");
			//result2 = SendManager.Send(4, 3, 0x87, 6, bytes, true, false, 3000, checkHash: false);
			//if (!result2.HasError)
			{
				//if (result2.Bytes.Count > 0)
				{
					Encoding enc8 = Encoding.UTF8;
					//string devListjson = enc8.GetString(result2.Bytes.ToArray());
					string devListjson = @"[{'ser_no': 1251839}, {'type': 241}, {'addr': 1}, {'als': 1}, {'n_parametrs': 4}, {'parametrs': {'1': 0, '2': 0, '3': 0, '4': 0, '5': 0, '6': 0, '7': 0, '8': 0}}],
[{ 'ser_no': 66299}, { 'type': 220}, { 'addr': 2}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 65832}, { 'type': 220}, { 'addr': 3}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66142}, { 'type': 220}, { 'addr': 4}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 65994}, { 'type': 220}, { 'addr': 5}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66264}, { 'type': 220}, { 'addr': 6}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66710}, { 'type': 220}, { 'addr': 7}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 65969}, { 'type': 220}, { 'addr': 8}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66347}, { 'type': 220}, { 'addr': 9}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66363}, { 'type': 220}, { 'addr': 10}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66227}, { 'type': 220}, { 'addr': 11}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66369}, { 'type': 220}, { 'addr': 12}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66738}, { 'type': 220}, { 'addr': 13}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }],
[{ 'ser_no': 66729}, { 'type': 220}, { 'addr': 14}, { 'als': 1}, { 'n_parametrs': 4}, { 'parametrs': { '1': 0, '2': 0, '3': 128, '4': 0, '5': 128, '6': 0, '7': 0, '8': 0} }]";
					//enc8.GetString(result2.Bytes.ToArray());

					//devListjson = "{\"devices\":" + devListjson + "}";

					List<Root> myDeserializedClass = JsonConvert.DeserializeObject<List<Root>>(devListjson);
					int idx = 1;
					/*if ((Cmd == 2) || (Cmd == 4))  //Переворачиваем список
					{
						myDeserializedClass.devices.Reverse();
					}*/
					GKDevice parentDvc = new GKDevice();
					foreach (Root d in myDeserializedClass)
					{
						var driver = DriversRepository1.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)d.type);//GKManager.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)driverTypeNo);
						if (driver != null)
						{
							var device = new GKDevice();
							device.Driver = driver;
							device.DriverUID = driver.UID;
							device.IntAddress = (byte)d.addr;
							device.SerialNo = (uint)d.ser_no;
							if (d.ser_no == prevSerialNo)
							{
								SubAddressId++;
								device.StrAddress = "";//prevAddr.ToString() + "." + SubAddressId;
								device.IntAddress = (byte)d.addr;
								if (parentDvc.Devices == null)
									parentDvc.Devices = new List<GKDevice>();
								parentDvc.Devices.Add(device);
							}
							else
							{
								parentDvc = device;
								device.StrAddress = "" + idx++;//device.IntAddress.ToString();
								SubAddressId = 0;
								prevAddr = device.IntAddress;
								devices.Add(device);
							}
							prevSerialNo = (uint)d.ser_no;


							var deviceGroup = deviceGroups.FirstOrDefault(x => x.SerialNo == d.ser_no);
							if (deviceGroup == null || d.ser_no == 0 ||
						 (driver.DriverType != GKDriverType.RSR2_AM_1
						 && driver.DriverType != GKDriverType.RSR2_ABTK
						 && driver.DriverType != GKDriverType.RSR2_MAV_1
						 && driver.DriverType != GKDriverType.RSR2_MAP4
						 && driver.DriverType != GKDriverType.RSR2_MVK8
						 && driver.DriverType != GKDriverType.RSR2_RM_1
						 && driver.DriverType != GKDriverType.RSR2_OPKZ
						 && driver.DriverType != GKDriverType.RSR2_KDKR
						 && driver.DriverType != GKDriverType.KD_KDZ
						 && driver.DriverType != GKDriverType.KD_KDK
						 && driver.DriverType != GKDriverType.KD_KDKV
						 && driver.DriverType != GKDriverType.KD_KDTD
						 && driver.DriverType != GKDriverType.RSR2_BMPK
						 && driver.DriverType != GKDriverType.RSR2_BMPKR_Part
						 && driver.DriverType != GKDriverType.RSR2_BMPP
						 && driver.DriverType != GKDriverType.RSR2_BMPUI
						 && driver.DriverType != GKDriverType.RSR2_ABShS))
							{
								deviceGroup = new DeviceGroup();
								deviceGroup.SerialNo = d.ser_no;
								deviceGroups.Add(deviceGroup);
							}
							deviceGroup.Devices.Add(device);
						}
					}
				}
			}
			//else
			{
				return true;
			}
			return true;
		}
		public static bool FindDevicesOnShleif(byte whom, int shleifNo, List<GKDevice> devices)
        {
			bool checkHash = true;
			for (int address = 1; address <= 255; address++)
			{
				var bytes = new List<byte>();
				bytes.Add(0);
				bytes.Add((byte)address);
				bytes.Add((byte)shleifNo);
				var result2 = new SendResult("");
				for (int i = 0; i < 1; i++)
				{
					result2 = SendManager.Send(whom, 3, 0x86, 6, bytes, true, false, 3000, checkHash: checkHash);
					if (!result2.HasError)
						break;
				}
				if (!result2.HasError)
				{
					if (result2.Bytes.Count == 6)
					{
						var driverTypeNo = result2.Bytes[1];
						var serialNo = BytesHelper.SubstructUInt(result2.Bytes, 2);

						var driver = DriversRepository1.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)driverTypeNo);//GKManager.Drivers.FirstOrDefault(x => x.DriverTypeNo == (ushort)driverTypeNo);
						if (driver != null)
						{
							var device = new GKDevice();
							device.Driver = driver;
							device.DriverUID = driver.UID;
							device.IntAddress = (byte)address;
							device.SerialNo = serialNo;
							devices.Add(device);

							var deviceGroup = deviceGroups.FirstOrDefault(x => x.SerialNo == serialNo);
							/*if (deviceGroup != null && deviceGroup.Devices.Count > 0 && deviceGroup.Devices[0].DriverType == GKDriverType.RSR2_KDKR
								&& (driver.DriverType == GKDriverType.KD_KDZ
								|| driver.DriverType == GKDriverType.KD_KDK
								|| driver.DriverType == GKDriverType.KD_KDKV
								|| driver.DriverType == GKDriverType.KD_KDTD)) { }

							else*/ if (deviceGroup == null || serialNo == 0 ||
								(driver.DriverType != GKDriverType.RSR2_AM_1
								&& driver.DriverType != GKDriverType.RSR2_ABTK
								&& driver.DriverType != GKDriverType.RSR2_MAV_1
								&& driver.DriverType != GKDriverType.RSR2_MAP4
								&& driver.DriverType != GKDriverType.RSR2_MVK8
								&& driver.DriverType != GKDriverType.RSR2_RM_1
								&& driver.DriverType != GKDriverType.RSR2_OPKZ
								&& driver.DriverType != GKDriverType.RSR2_KDKR
								&& driver.DriverType != GKDriverType.KD_KDZ
								&& driver.DriverType != GKDriverType.KD_KDK
								&& driver.DriverType != GKDriverType.KD_KDKV
								&& driver.DriverType != GKDriverType.KD_KDTD
								&& driver.DriverType != GKDriverType.RSR2_BMPK
								&& driver.DriverType != GKDriverType.RSR2_BMPKR_Part
								&& driver.DriverType != GKDriverType.RSR2_BMPP
								&& driver.DriverType != GKDriverType.RSR2_BMPUI
								&& driver.DriverType != GKDriverType.RSR2_ABShS))
							{
								deviceGroup = new DeviceGroup();
								deviceGroup.SerialNo = serialNo;
								deviceGroups.Add(deviceGroup);
							}
							deviceGroup.Devices.Add(device);
						}
					}
				}
				else
				{
					break;
				}
			}


			return true;
		}

		public static bool WriteDeviceRTUParameters(byte whom, GKDevice device, byte ALSnum)
        {
			var data = new List<byte>();
			data.AddRange(BytesHelper.UIntToBytes(device.SerialNo));
			data.AddRange(BytesHelper.ShortToBytes(device.Driver.DriverTypeNo));
			data.Add((byte)device.IntAddress);
			data.Add(ALSnum);
			var sendResult = new SendResult("");
			ushort v;
			if (device.Driver.DriverTypeNo == 0x102) //МОПС
			{
				ushort pn = Convert.ToUInt16(7); //7 параметров
				data.AddRange(BytesHelper.ShortToBytes(pn));

				data.AddRange(BytesHelper.UIntToBytes(device.Driver.RSspeed));
				data.AddRange(BytesHelper.ShortToBytes(device.Driver.RSparity));
				data.AddRange(BytesHelper.ShortToBytes(device.Driver.RSdatabit));
				data.AddRange(BytesHelper.ShortToBytes(device.Driver.RSstopbit));
				data.AddRange(BytesHelper.ShortToBytes(device.Driver.RSReadtimeout));
				data.AddRange(BytesHelper.ShortToBytes(device.Driver.RSWritetimeout));

				v = Convert.ToUInt16(device.Driver.KAUlogicalNum);
				data.AddRange(BytesHelper.ShortToBytes(v));
				sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
				var bytes = sendResult.Bytes;
				if (sendResult.HasError)
					return false;
				return true;
			}
			return false;
		}

		public static bool WriteROMtoDevice(byte whom, GKDevice device, byte[] packData, byte packNum, byte packTotal)
		{
			var data = new List<byte>();
			data.Add(packTotal);
			data.Add(packNum);
			data.AddRange(packData);
			/*for(int i=0;i<packData.Length; i++)
            {
				data.Add(packData[i]);
			}*/
			var sendResult = new SendResult("");
			sendResult = SendManager.Send(whom, (ushort)data.Count, 0x15, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return false;
		}

		public static bool WriteDeviceParameters(byte whom, GKDevice device, byte ALSnum, byte packNum, byte packTotal)
		{
			#region old code
			/* OLD CODE var data = new List<byte>();
			data.AddRange(BytesHelper.UIntToBytes(device.SerialNo));
			data.AddRange(BytesHelper.ShortToBytes(device.Driver.DriverTypeNo));
			data.Add((byte)device.IntAddress);
			data.Add(ALSnum);
			if (device.Driver.Properties.Count == 0)
				return true;
			ushort pn = Convert.ToUInt16(device.Driver.Properties[device.Driver.Properties.Count - 1].No + 1);
			data.AddRange(BytesHelper.ShortToBytes(pn));
			//List<GKDriverProperty> cmbProps = new System.Collections.Generic.List<GKDriverProperty>();
			byte pNum = 0;
			uint pValue1 = 0;
			var sendResult = new SendResult("");
			ushort v;
			foreach (GKDriverProperty p in device.Driver.Properties)
			{
				if (pNum == p.No)
				{
					if ((p.DriverPropertyType == GKDriverPropertyTypeEnum.IntType) || (p.DriverPropertyType == GKDriverPropertyTypeEnum.EnumType))
					{
						if (p.IsLowByte)
							pValue1 = pValue1 | p.Default;
						else
							pValue1 = p.Default;
					}
				}
				else
				{
					data.Add(pNum);
					data.Add(0);
					v = Convert.ToUInt16(pValue1);
					data.AddRange(BytesHelper.ShortToBytes(v));
					sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
					var bytes = sendResult.Bytes;
					if (sendResult.HasError)
						return false;

					pNum = p.No;
					pValue1 = 0;
					if ((p.DriverPropertyType == GKDriverPropertyTypeEnum.IntType) || (p.DriverPropertyType == GKDriverPropertyTypeEnum.EnumType))
					{
						if (p.IsLowByte)
							pValue1 = pValue1 | p.Default;
						else
							pValue1 = p.Default;
					}
				}
			}
			data.Add(pNum);
			v = Convert.ToUInt16(pValue1);
			data.AddRange(BytesHelper.ShortToBytes(v));
			data.Add(0);
			sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
			return true;*/
			#endregion
			var data = new List<byte>();
			data.Add(packNum);
			data.Add(packTotal);
			data.AddRange(BytesHelper.UIntToBytes(device.SerialNo));
			data.AddRange(BytesHelper.ShortToBytes(device.Driver.DriverTypeNo));
			data.Add((byte)device.IntAddress);
			data.Add(ALSnum);
			var sendResult = new SendResult("");
			ushort v;
			if (device.Driver.DriverTypeNo == 0x102) //МОПС
			{
				ushort pn = Convert.ToUInt16(10); //10 параметров
				if (device.Driver.Mac1 != "")
					pn++;
				if (device.Driver.Mac2 != "")
					pn++;
				data.AddRange(BytesHelper.ShortToBytes(pn));
				//IP1
				string[] ip1bytes = device.Driver.IPaddress1.Split('.');
				foreach (string ipb in ip1bytes)
				{
					try
					{
						data.Add(byte.Parse(ipb));
					}

                    catch { return false; }
				}
				//Mask1
				string[] mask1bytes = device.Driver.Mask1.Split('.');
				foreach (string ipb in mask1bytes)
				{
					try
					{
						data.Add(byte.Parse(ipb));
					}

					catch { return false; }
				}

				//IP2
				string[] ip2bytes = device.Driver.IPaddress2.Split('.');
				foreach (string ipb in ip2bytes)
				{
					try
					{
						data.Add(byte.Parse(ipb));
					}

					catch { return false; }
				}
				//Mask2
				string[] mask2bytes = device.Driver.Mask2.Split('.');
				foreach (string ipb in mask2bytes)
				{
					try
					{
						data.Add(byte.Parse(ipb));
					}

					catch { return false; }
				}
				v = Convert.ToUInt16(device.Driver.KAUlogicalNum);
				data.AddRange(BytesHelper.ShortToBytes(v));
				v = Convert.ToUInt16(device.Driver.MDBethernetPortNum);
				data.AddRange(BytesHelper.ShortToBytes(v));
				//Mac1
				string[] mac1bytes = device.Driver.Mac1.Split(':');
				foreach (string macb in mac1bytes)
				{
					try
					{
						data.Add(byte.Parse(macb, NumberStyles.HexNumber));
					}
					catch { return false; }
				}
				//Mac1
				string[] mac2bytes = device.Driver.Mac2.Split(':');
				foreach (string macb in mac2bytes)
				{
					try
					{
						data.Add(byte.Parse(macb, NumberStyles.HexNumber));
					}

					catch { return false; }
				}
			}
			else
			{
				if (device.Driver.Properties.Count == 0)
					return true;
				ushort pn = Convert.ToUInt16(device.Driver.Properties[device.Driver.Properties.Count - 1].No + 1);
				data.AddRange(BytesHelper.ShortToBytes(pn));
				//List<GKDriverProperty> cmbProps = new System.Collections.Generic.List<GKDriverProperty>();
				byte pNum = 0;
				uint pValue1 = 0;
				foreach (GKDriverProperty p in device.Driver.Properties)
				{
					if (pNum == p.No)
					{
						if ((p.DriverPropertyType == GKDriverPropertyTypeEnum.IntType) || (p.DriverPropertyType == GKDriverPropertyTypeEnum.EnumType))
						{
							if (p.IsLowByte)
								pValue1 = pValue1 | p.Default;
							else
								pValue1 = p.Default;
						}
					}
					else
					{
						//data.Add(pNum);
						v = Convert.ToUInt16(pValue1);
						data.AddRange(BytesHelper.ShortToBytes(v));
						//data.Add(0);
						//sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
						//var bytes = sendResult.Bytes;
						//if (sendResult.HasError)
						//return false;

						pNum = p.No;
						pValue1 = 0;
						if ((p.DriverPropertyType == GKDriverPropertyTypeEnum.IntType) || (p.DriverPropertyType == GKDriverPropertyTypeEnum.EnumType))
						{
							if (p.IsLowByte)
								pValue1 = pValue1 | p.Default;
							else
								pValue1 = p.Default;
						}
					}
				}
				//data.Add(pNum);
				v = Convert.ToUInt16(pValue1);
				data.AddRange(BytesHelper.ShortToBytes(v));
				//data.Add(0);
			}

			sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return true;
		}
        public static bool WriteDeviceCommand(byte whom, GKDevice device, byte ALSnum, GKStateBit stBit)
		{
			var data = new List<byte>();
			data.AddRange(BytesHelper.UIntToBytes(device.SerialNo));
			data.AddRange(BytesHelper.ShortToBytes(device.Driver.DriverTypeNo));
			data.Add((byte)device.IntAddress);
			data.Add(ALSnum);
			data.Add(2);
			data.Add((byte)stBit);
			data.Add(0);
			var sendResult = SendManager.Send(whom, (ushort)data.Count, 0x0D, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return true;
		}
		public static bool WriteDeviceGroupCommand(List<byte> data)
		{
			var sendResult = SendManager.Send(4, (ushort)data.Count, 0x0E, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return true;
		}


		public static bool FinalizeWritingDeviceParameters(byte whom, byte alsnum)
        {
			var data = new List<byte>();
			data.Add(0xff);
			data.Add(0xff);
			data.Add(alsnum);
			var sendResult = SendManager.Send(whom, (ushort)data.Count, 17, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return true;
        }
		public static bool RebootMOPSCommand()
        {
			var data = new List<byte>();
			var sendResult = SendManager.Send(4, (ushort)data.Count, 3, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			return true;
		}

		public static bool RequestDataFromKAU(byte whom, out List<MyData> dlist, byte ALSnum)
		{
			dlist = new List<MyData>();
			var data = new List<byte>();
			data.Add(ALSnum);
			var sendResult = SendManager.Send(whom, (ushort)data.Count, 0x20, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			if (bytes.Count > 0)
            {
				try
				{
					Encoding enc8 = Encoding.UTF8;
					string devListjson = enc8.GetString(bytes.ToArray());
					dlist = JsonConvert.DeserializeObject<List<MyData>>(devListjson);
				}
				catch(Exception ex) { string e = ex.ToString(); return false; }
            }
			return true;
		}
		public static string Res0x22 = "";
		public static bool RequestSettingsFromKAU(byte whom, out KAUConfig config)//, out List<MyData> dlist, byte ALSnum)
		{
			config = new KAUConfig();
			var data = new List<byte>();
			var sendResult = SendManager.Send(whom, (ushort)data.Count, 0x22, ushort.MaxValue, data);
			var bytes = sendResult.Bytes;
			if (sendResult.HasError)
				return false;
			if (bytes.Count > 0)
			{
				try
				{
					Encoding enc8 = Encoding.UTF8;
					string devListjson = enc8.GetString(bytes.ToArray());
					Res0x22 = devListjson;
					config = JsonConvert.DeserializeObject<KAUConfig>(devListjson);
				}
				catch { return false; }
			}
			return true;
		}


		public static bool WriteConfigToDevice(byte whom, CommonDatabase commonDatabase, bool checkReserve = true, bool checkHash = true)
		{
			/*var deviceName = "";
			if (commonDatabase is GkDatabase)
			{
				deviceName = commonDatabase.RootDevice.Parent.DriverType == GKDriverType.System
					? commonDatabase.RootDevice.PresentationName
					: $"{commonDatabase.RootDevice.Parent.PresentationName} ({commonDatabase.RootDevice.Parent.Children[0].PresentationName}.{commonDatabase.RootDevice.Parent.Children[1].PresentationName})";
			}
			else
			{
				deviceName = commonDatabase.RootDevice.Parent.DriverType == GKDriverType.GK
					? commonDatabase.RootDevice.Parent.PresentationName
					: $"{commonDatabase.RootDevice.Parent.PresentationName} ({commonDatabase.RootDevice.Parent.Children[0].PresentationName}.{commonDatabase.RootDevice.Parent.Children[1].PresentationName})";
			}*/
			//using (var gkLifecycleManager = new GKLifecycleManager(commonDatabase.RootDevice, "Запись дескрипторов"))
			{
				//GKDescriptorsWriterLogger.Log(deviceName, $"Запись дескрипторов {commonDatabase.RootDevice.PresentationName}");
				for (var descriptorNo = 0; descriptorNo < commonDatabase.Descriptors.Count; descriptorNo++)
				{
					var descriptor = commonDatabase.Descriptors[descriptorNo];
					//gkLifecycleManager.Progress(descriptorNo + 1, commonDatabase.Descriptors.Count);
					//var progressStage = commonDatabase.RootDevice.PresentationName + ": запись " + descriptor.GKBase.PresentationName + " " + "(" + descriptor.GetDescriptorNo() + ")" + " из " + commonDatabase.Descriptors.Count;
					//GKProcessorManager.DoProgress(progressStage, progressCallback, clientUID);

					var packs = CreateDescriptors(descriptor);
					foreach (var pack in packs)
					{
						for (var i = 0; i < 5; i++)
						{
							var sendResult = SendManager.Send(whom, (ushort)(pack.Count), 17, 0, pack, checkReserve: checkReserve, checkHash: checkHash);
							if (sendResult.HasError)
							{
								if (i >= 4)
								{
									//GKProcessorManager.StopProgress(progressCallback, clientUID);
									//gkLifecycleManager.SetError("Ошибка при записи дескриптора");
									//GKDescriptorsWriterLogger.Log(deviceName, $"Ошибка при записи дескриптора {commonDatabase.RootDevice.PresentationName} : {descriptor.GKBase.PresentationName}");
									return false;
								}
							}
							else
								break;
						}
					}
				}
				//GKDescriptorsWriterLogger.Log(deviceName, $"Запись завершающего дескриптора {commonDatabase.RootDevice.PresentationName}");
				//GKProcessorManager.DoProgress(commonDatabase.RootDevice.PresentationName + " Запись завершающего дескриптора", progressCallback, clientUID);
				//WriteEndDescriptor(commonDatabase, checkReserve);
				//GKDescriptorsWriterLogger.Log(deviceName, $"Запись дескрипторов {commonDatabase.RootDevice.PresentationName} завершена");
				return true;
			}
			List<List<byte>> CreateDescriptors(BaseDescriptor descriptor)
			{
				var packs = new List<List<byte>>();
				for (var packNo = 0; packNo <= descriptor.AllBytes.Count / 256; packNo++)
				{
					var packLenght = Math.Min(256, descriptor.AllBytes.Count - packNo * 256);
					var packBytes = descriptor.AllBytes.Skip(packNo * 256).Take(packLenght).ToList();

					if (packBytes.Count > 0)
					{
						var resultBytes = new List<byte>();
						var descriptorNo = descriptor.GetDescriptorNo();
						resultBytes.AddRange(BytesHelper.ShortToBytes(descriptorNo));
						resultBytes.Add((byte)(packNo + 1));
						resultBytes.AddRange(packBytes);
						packs.Add(resultBytes);
					}
				}
				return packs;
			}
		}

	}

	public enum GKDriverType
	{
		[Description("Локальная сеть")]
		System = 0,

		[Description("ГК")]
		GK = 1,

		[Description("Индикатор ГК")]
		GKIndicator = 2,

		[Description("Линия ГК")]
		GKLine = 3,

		[Description("Реле ГК")]
		GKRele = 4,

		[Description("Индикатор Неисправность МОПС")]
		KAUIndicator = 7,

		[Description("МОПС RS")]
		RSR2_KAU = 29,

		[Description("АЛС")]
		RSR2_KAU_Shleif = 30,

		[Description("ИПР")]
		RSR2_HandDetector = 31,

		[Description("ИПД")]
		RSR2_SmokeDetector = 32,

		[Description("ИПК")]
		RSR2_CombinedDetector = 33,

		[Description("МР")]
		RSR2_RM_1 = 35,

		[Description("МР-2")]
		RSR2_RM_2 = 36,

		[Description("МА")]
		RSR2_AM_1 = 37,

		[Description("МА-4")]
		RSR2_AM_4 = 38,

		[Description("МА-2")]
		RSR2_AM_2 = 39,

		[Description("МДУ-1")]
		RSR2_MDU = 40,

		[Description("МДУ24")]
		RSR2_MDU24 = 41,

		[Description("МАП")]
		RSR2_MAP4 = 42,

		[Description("МВК")]
		RSR2_MVK8 = 43,

		[Description("МАП-4")]
		RSR2_MAP4_Group = 44,

		[Description("МВК-8")]
		RSR2_MVK8_Group = 45,

		[Description("ИПТ")]
		RSR2_HeatDetector = 46,

		[Description("ППУ ДН")]
		RSR2_Bush_Drenazh = 47,

		[Description("ППУ ЖН")]
		RSR2_Bush_Jokey = 48,

		[Description("ППУ ПН")]
		RSR2_Bush_Fire = 49,

		[Description("ППУ В")]
		RSR2_Bush_Shuv = 50,

		[Description("БУЗ КВ")]
		RSR2_Valve_KV = 51,

		[Description("БУЗ КВ-МВ")]
		RSR2_Valve_KVMV = 52,

		[Description("БУЗ КВ-ДУ")]
		RSR2_Valve_DU = 53,

		[Description("ОПС")]
		RSR2_OPS = 58,

		[Description("ОПЗ")]
		RSR2_OPZ = 59,

		[Description("МВП")]
		RSR2_MVP = 60,

		[Description("Линия МВП")]
		RSR2_MVP_Part = 61,

		[Description("ИО-ИК R2")]
		RSR2_GuardDetector = 63,

		[Description("Контроллер Wiegand")]
		RSR2_CardReader = 64,

		[Description("МР-4")]
		RSR2_RM_4 = 65,

		[Description("Буз КВ")]
		RSR2_Buz_KV = 66,

		[Description("Буз КВ-МВ")]
		RSR2_Buz_KVMV = 67,

		[Description("Буз КВ-ДУ")]
		RSR2_Buz_KVDU = 68,

		[Description("ИО-ПЗ")]
		RSR2_GuardDetectorSound = 69,

		[Description("Отражение ГК")]
		GKMirror = 70,

		[Description("Образ извещательных устройств")]
		DetectorDevicesMirror = 71,

		[Description("Образ пожарных зон")]
		FireZonesMirror = 72,

		[Description("Образ исполнительных устройств")]
		ControlDevicesMirror = 73,

		[Description("Образ зон пожаротушения")]
		FirefightingZonesMirror = 74,

		[Description("Образ охранных зон")]
		GuardZonesMirror = 75,

		[Description("Образ направлений")]
		DirectionsMirror = 76,

		[Description("Группа индикаторов")]
		GKIndicatorsGroup = 77,

		[Description("Группа реле")]
		GKRelaysGroup = 78,

		[Description("Оповещатель свето-звуковой")]
		RSR2_OPSZ = 79,

		[Description("Звуковой оповещатель комбинированный")]
		RSR2_OPKS = 80,

		[Description("Световой оповещатель комбинированный")]
		RSR2_OPKZ = 81,

		[Description("АБПЦ")]
		RSR2_ABPC = 82,

		[Description("АБШС")]
		RSR2_ABShS = 83,

		[Description("АБШС-2")]
		RSR2_ABShS_Group = 84,

		[Description("АБТК")]
		RSR2_ABTK = 85,

		[Description("АБТК-2")]
		RSR2_ABTK_Group = 86,

		[Description("ИПТЭ")]
		RSR2_HeatDetectorEridan = 87,

		[Description("ИПРЭ")]
		RSR2_HandDetectorEridan = 88,

		[Description("ИОЛИТ")]
		RSR2_IOLIT = 89,

		[Description("УДП")]
		RSR2_Button = 98,

		[Description("МВК-4")]
		RSR2_MVK4_Group = 99,

		[Description("МВК-2")]
		RSR2_MVK2_Group = 100,

		[Description("НСЧ")]
		RSR2_CodeCardReader = 101,

		[Description("ЗОВ")]
		RSR2_ZOV = 102,

		[Description("СКОПА")]
		RSR2_SCOPA = 103,

		[Description("Контроллер доступа")]
		RSR2_KDKR = 104,

		[Description("Линия КД")]
		RSR2_KDKR_Part = 105,

		[Description("Замок КД")]
		KD_KDZ = 106,

		[Description("Концевик(кнопка) КД")]
		KD_KDK = 107,

		[Description("КВ КД")]
		KD_KDKV = 108,

		[Description("ТД КД")]
		KD_KDTD = 109,

		[Description("ИОВ")]
		RSR2_HandGuardDetector = 110,

		[Description("ИС")]
		RSR2_IS = 111,

		[Description("Модуль изолятора")]
		RSR2_MI = 113,

		[Description("БМП")]
		RSR2_BMPKR = 114,

		[Description("БМПК")]
		RSR2_BMPK = 115,

		[Description("БМПУИ")]
		RSR2_BMPUI = 116,

		[Description("БМПП")]
		RSR2_BMPP = 117,

		[Description("Линия БМП")]
		RSR2_BMPKR_Part = 118,

		[Description("КПП")]
		RSR2_KPP = 122,

		[Description("ГК")]
		ReserveSystem = 123,

		[Description("ИВЭПР")]
		RSR2_IVEPR = 124,

		[Description("МАП-2")]
		RSR2_MAP2_Group = 125,

		[Description("МТС")]
		RSR2_MTS = 128,

		[Description("РР-РК")] //
		Aleksa_RR = 129,

		[Description("БУ-РК")] //
		Aleksa_BU = 130,

		[Description("КТ-РК")] //
		Aleksa_KT = 131,

		[Description("МСП")]
		RSR2_MSP = 135,

		[Description("МСВ")]
		RSR2_MSV = 136,

		[Description("МАВ")]
		RSR2_MAV_1 = 137,

		[Description("МАВ-2")]
		RSR2_MAV_2 = 138,

		[Description("МАВ-4")]
		RSR2_MAV_4 = 139,

		[Description("СКОПА-З")]
		RSR2_SCOPA_SZ = 140,

		[Description("СКОПА-С")]
		RSR2_SCOPA_S = 141,

		[Description("СКОПА-З")]
		RSR2_SCOPA_Z = 142,

		[Description("ИДМС")]
		RSR2_IDMS = 143,

		[Description("ИЗМС")]
		RSR2_IZMS = 144,

		[Description("ОМСП")]
		RSR2_OMSP = 145,

		[Description("ИВМС")]
		RSR2_IVMS = 146,

		[Description("ИММС")]
		RSR2_IMMS = 147,

		[Description("ИПС")]
		RSR2_IPS = 148,
	}

	public class DeviceGroup
	{
		public DeviceGroup()
		{
			Devices = new List<object>();
		}
		public long SerialNo { get; set; }
		public List<object> Devices { get; set; }
	}


	public class SendResult
	{
		public List<byte> Bytes { get; set; }
		public bool HasError { get; set; }
		public string Error { get; set; }

		public SendResult(string error)
		{
			HasError = true;
			Error = error;
			Bytes = new List<byte>();
		}

		public SendResult(List<byte> bytes)
		{
			Bytes = bytes;
			HasError = false;
		}
	}

	public static class BytesHelper
	{
		public static List<byte> ShortToBytes(ushort shortValue)
		{
			return BitConverter.GetBytes(shortValue).ToList();
		}

		public static List<byte> IntToBytes(int intValue)
		{
			return BitConverter.GetBytes(intValue).ToList();
		}

		public static List<byte> UIntToBytes(uint intValue)
		{
			return BitConverter.GetBytes(intValue).ToList();
		}

		public static List<byte> StringDescriptionToBytes(string str, int length = 32)
		{
			if (str == null)
				str = "";
			if (str.Length > length)
				str = str.Substring(0, length);
			var spaceIndex = Win1251Encoding.Instance.GetBytes(" ").Single();
			var bytes = Win1251Encoding.Instance.GetBytes(str).ToList();
			for (int i = 0; i < length - str.Length; i++)
			{
				bytes.Add(spaceIndex);
			}
			return bytes;
		}

		public static string BytesToStringDescription(List<byte> bytes)
		{
			bytes = bytes.Skip(8).Take(32).ToList();
			string result = Win1251Encoding.Instance.GetString(bytes.ToArray()).TrimEnd();
			return result;
		}

		public static string BytesToStringDescription(List<byte> bytes, int startIndex)
		{
			bytes = bytes.Skip(startIndex).Take(32).ToList();
			string result = Win1251Encoding.Instance.GetString(bytes.ToArray()).TrimEnd();
			return result;
		}

		public static string BytesToString(List<byte> bytes)
		{
			var stringBuilder = new StringBuilder();
			if (bytes != null)
			{
				for (int index = 0; index < bytes.Count; index++)
				{
					var b = bytes[index];
					if (index % 16 == 0 && index > 0)
						stringBuilder.AppendLine("");

					stringBuilder.Append(b.ToString("x2") + " ");
				}
			}
			return stringBuilder.ToString();
		}

		public static int SubstructInt(List<byte> bytes, int startByte)
		{
			if (startByte + 4 > bytes.Count)
			{
				return 0;
			}
			var result = 1 * bytes[startByte + 0] + 256 * bytes[startByte + 1] + 256 * 256 * bytes[startByte + 2] + 256 * 256 * 256 * bytes[startByte + 3];
			return result;
		}

		public static uint SubstructUInt(List<byte> bytes, int startByte)
		{
			if (startByte + 4 > bytes.Count)
			{
				return 0;
			}
			var result = (uint)(1 * bytes[startByte + 0] + 256 * bytes[startByte + 1] + 256 * 256 * bytes[startByte + 2] + 256 * 256 * 256 * bytes[startByte + 3]);
			return result;
		}

		public static ushort SubstructShort(List<byte> bytes, int startByte)
		{
			if (startByte + 2 > bytes.Count)
			{
				return 0;
			}
			var result = 1 * bytes[startByte + 0] + 256 * bytes[startByte + 1];
			return (ushort)result;
		}

		public static DateTime SubstructDate(List<byte> bytes, int startByte)
		{
			var totalSeconds = BytesHelper.SubstructUInt(bytes, startByte);
			var result = new DateTime(2000, 1, 1);
			result = result.AddSeconds(totalSeconds);
			return result;
		}

		public static List<List<byte>> SplitBytes(List<byte> bytes, int packSize, int totalPacks, bool withAD = false)
		{
			var packs = new List<List<byte>>();
			for (int packNo = 0; packNo <= bytes.Count() / packSize; packNo++)
			{
				var pack = bytes.Skip(packNo * packSize).Take(packSize).ToList();
				if (pack.Count > 0)
				{
					for (int i = pack.Count; i < packSize; i++)
						pack.Add(0);
					if (withAD)
						pack.Add(0);
					packs.Add(pack);
				}
			}
			if (withAD)
				packs.LastOrDefault()[packSize] = 0xad;
			else
			{
				for (int i = packs.Count; i < totalPacks; i++)
				{
					var pack = new List<byte>();
					for (int j = 0; j < packSize; j++)
						pack.Add(0);
					packs.Add(pack);
				}
			}
			return packs;
		}

		public static List<byte> DateToBytes(DateTime date)
		{
			var secondsPeriod = (new DateTime(date.Year, date.Month, date.Day) - new DateTime(2000, 1, 1)).TotalSeconds;
			return BytesHelper.UIntToBytes((uint)secondsPeriod);
		}
	}

	public class Win1251Encoding : Encoding
	{
		static Win1251Encoding _instance = new Win1251Encoding();
		public static Encoding Instance
		{
			get { return _instance; }
		}

		static string alpha = "\0\u0001\u0002\u0003\u0004\u0005\u0006\a\b\t\n\v\f\r\u000e\u000f\u0010\u0011\u0012\u0013\u0014\u0015\u0016\u0017\u0018\u0019\u001a\u001b\u001c\u001d\u001e\u001f !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\u007fЂЃ‚ѓ„…†‡€‰Љ‹ЊЌЋЏђ‘’“”•–—\u0098™љ›њќћџ ЎўЈ¤Ґ¦§Ё©Є«¬­®Ї°±Ііґµ¶·ё№є»јЅѕїАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя";
		public override int GetByteCount(char[] chars, int index, int count)
		{
			return count;
		}

		public override int GetBytes(char[] chars, int charIndex, int charCount, byte[] bytes, int byteIndex)
		{
			byte questionIndex = (byte)alpha.IndexOf('?');
			for (int i = 0; i < charCount; i++)
			{
				int toIndex = byteIndex + i;
				int index = alpha.IndexOf(chars[charIndex + i]);
				if (index == -1)
					bytes[toIndex] = questionIndex;
				else
					bytes[toIndex] = (byte)index;
			}
			return charCount;
		}

		public override int GetCharCount(byte[] bytes, int index, int count)
		{
			return count;
		}

		public override int GetChars(byte[] bytes, int byteIndex, int byteCount, char[] chars, int charIndex)
		{
			for (int i = 0; i < byteCount; i++)
			{
				chars[i + charIndex] = alpha[bytes[byteIndex + i]];
			}
			return byteCount;
		}

		public override int GetMaxByteCount(int charCount)
		{
			return charCount;
		}

		public override int GetMaxCharCount(int byteCount)
		{
			return byteCount;
		}

	}

	public class BytesDescriptor
	{
		public int No { get; set; }
		public DescriptorType? DescriptorType { get; set; }
		public int GKDescriptorNo { get; set; }
		public int KAUDescriptorNo { get; set; }
		public ushort ControllerAdress { get; set; }
		public ushort AddressOnController { get; set; }
		public ushort PhysicalAdress { get; set; }
		public List<byte> DeviceType { get; set; } = new List<byte>();
		public List<byte> Address { get; set; } = new List<byte>();
		public List<byte> Description { get; set; } = new List<byte>();
		public List<byte> Offset { get; set; } = new List<byte>();
		public List<byte> InputDependensesCount { get; set; } = new List<byte>();
		public List<byte> InputDependenses { get; set; } = new List<byte>();
		public List<byte> OutputDependensesCount { get; set; } = new List<byte>();
		public List<byte> OutputDependenses { get; set; } = new List<byte>();
		public List<byte> FormulaBytes { get; set; } = new List<byte>();
		public List<byte> ParametersCount { get; set; } = new List<byte>();
		public List<byte> Parameters { get; set; } = new List<byte>();
		public List<byte> AllBytes { get; set; } = new List<byte>();
	}

	public enum DescriptorType
	{
		Device,
		Zone,
		Direction,
		PumpStation,
		MPT,
		Delay,
		Pim,
		GuardZone,
		Code,
		Door,
		TD2I
	}

	public abstract class DescriptorReaderBase
	{
		public abstract bool ReadConfiguration(byte whom);
		public List<BytesDescriptor> Descriptors { get; protected set; }
		public string Error { get; protected set; }
	}

	public class GkDescriptorsReaderBase : DescriptorReaderBase
	{
		override public bool ReadConfiguration(byte whom)
		{
			Descriptors = new List<BytesDescriptor>();
			var result = SendManager.Ping(whom);
			if (result.HasError)
			{
				Error = "Устройство недоступно";
				return false;
			}
			if (!SendManager.GoToTechnologicalRegime(whom))
			{
				Error = "Не удалось перевести в технологический режим\n" +
						"Устройство не доступно, либо вашего " +
						"IP адреса нет в списке разрешенного адреса ГК";
				return false;
			}

			ReadConfig(whom);

			SendManager.GoToWorkingRegime(whom);

			return Error == null;
		}


		void ReadConfig(byte whom)
		{
			/*var gkFileReaderWriter = new GKFileReaderWriter();
			var gkFileInfo = gkFileReaderWriter.ReadInfoBlock(gkControllerDevice);
			if (gkFileReaderWriter.Error != null)
			{
				Error = gkFileReaderWriter.Error;
				GKProcessorManager.StopProgress(progressCallback, clientUID);
				return;
			}
			progressCallback = GKProcessorManager.StartProgress("Чтение конфигурации " + gkControllerDevice.PresentationName, "", gkFileInfo.DescriptorsCount, true, GKProgressClientType.Administrator, clientUID);
			*/
			ushort descriptorNo = 0;
			while (true)
			{
				/*if (progressCallback.IsCanceled)
				{
					Error = "Операция отменена";
					break;
				}*/
				descriptorNo++;
				//GKProcessorManager.DoProgress("Чтение базы данных объектов ГК " + descriptorNo, progressCallback, clientUID);

				var isEndOfRead = false;
				var bytesDescriptor = new BytesDescriptor { No = descriptorNo, GKDescriptorNo = descriptorNo };
				var isPackExists = true;
				byte packNo = 1;
				var descriptorNoBytes = BitConverter.GetBytes(descriptorNo);
				do
				{
					var data = new List<byte>(descriptorNoBytes) { packNo++ };

					for (int i = 0; i < 3; i++)
					{
						var sendResult = SendManager.Send(whom, 3, 19, ushort.MaxValue, data);
						var bytes = sendResult.Bytes;

						if (!bytes.Any())
						{
							isPackExists = false;
							break;
						}

						if (!sendResult.HasError && bytes.Count >= 5)
						{
							if (bytes[3] == 0xff && bytes[4] == 0xff)
							{
								isEndOfRead = true;
								isPackExists = false;
								break;
							}
							bytesDescriptor.AllBytes.AddRange(bytes.Skip(3));
							break;
						}
					}
				} while (isPackExists);

				if (bytesDescriptor.AllBytes.Any())
				{
					bytesDescriptor.DeviceType = bytesDescriptor.AllBytes.Take(2).ToList();
					bytesDescriptor.Address = bytesDescriptor.AllBytes.Skip(2).Take(6).ToList();
					bytesDescriptor.Description = bytesDescriptor.AllBytes.Skip(8).Take(32).ToList();
					bytesDescriptor.ControllerAdress = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, 2);
					bytesDescriptor.AddressOnController = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, 4);
					bytesDescriptor.PhysicalAdress = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, 6);

					var offsetPosition = 40;
					var offsetToParameters = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, offsetPosition);
					bytesDescriptor.Offset = BytesHelper.ShortToBytes(offsetToParameters);
					var outputDependencesPosition = offsetPosition + 2;
					var inputDependencesCount = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, offsetPosition + 2);
					bytesDescriptor.InputDependenses = bytesDescriptor.AllBytes.GetRange(offsetPosition + 4, inputDependencesCount * 2);
					bytesDescriptor.InputDependensesCount = BytesHelper.ShortToBytes(inputDependencesCount);
					outputDependencesPosition = offsetPosition + 2 + 2 + inputDependencesCount * 2;

					var outputDependencesCount = BytesHelper.SubstructShort(bytesDescriptor.AllBytes, outputDependencesPosition);
					bytesDescriptor.OutputDependensesCount = BytesHelper.ShortToBytes(outputDependencesCount);
					bytesDescriptor.OutputDependenses = bytesDescriptor.AllBytes.GetRange(outputDependencesPosition + 2, outputDependencesCount * 2);

					var formulaPosition = outputDependencesPosition + 2 + outputDependencesCount * 2;
					bytesDescriptor.FormulaBytes = bytesDescriptor.AllBytes.GetRange(formulaPosition, offsetToParameters - formulaPosition);

					bytesDescriptor.ParametersCount = BytesHelper.ShortToBytes(BytesHelper.SubstructShort(bytesDescriptor.AllBytes, offsetToParameters));
					bytesDescriptor.Parameters = bytesDescriptor.AllBytes.GetRange(offsetToParameters + 2, BytesHelper.SubstructShort(bytesDescriptor.AllBytes, offsetToParameters) * 4);

					Descriptors.Add(bytesDescriptor);
				}
				if (isEndOfRead)
				{
					return;
				}
			}
		}
	}

	public class lDevice
	{
		public uint ser_no { set; get; }
		public int type { set; get; }
		public int addr { set; get; }
	}

	public class lRoot
	{
		public List<lDevice> devices { set; get; }
	}

	public class Parametrs
	{
		public int _1 { get; set; }
		public int _2 { get; set; }
		public int _3 { get; set; }
		public int _4 { get; set; }
		public int _5 { get; set; }
		public int _6 { get; set; }
		public int _7 { get; set; }
		public int _8 { get; set; }
	}

	public class Root
	{
		public int ser_no { get; set; }
		public int? type { get; set; }
		public int? addr { get; set; }
		public int? als { get; set; }
		public int? n_parametrs { get; set; }
		public Parametrs parametrs { get; set; }
	}

}
