﻿using System;

namespace GlobalCF
{
	public static class KD_KDZ_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xF4,
				DriverType = GKDriverType.KD_KDZ,
				UID = new Guid("2E9F2B6A-D707-4007-842C-664D6BCBE9F1"),
				Name = "Замок КД",
				ShortName = "КДЗ",
				IsControlDevice = true,
				HasLogic = true,
				IsPlaceable = true,
				IsAutoCreate = true,
				IsSeparateAutoCreateAddresses = true,
				AutoCreateAddresses = new System.Collections.Generic.List<byte> { 1, 6 }
			};

			GKDriversHelper.AddControlAvailableStates(driver);
			driver.AvailableStateBits.Add(GKStateBit.Off);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.AutoOff);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.On);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Off);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.Test);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.Fire2);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InManual);
			
			return driver;
		}
	}
}
