﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.IO;
using System.Collections.ObjectModel;

namespace GlobalCF
{
    public class MsgConsoleCS
    {
        public ObservableCollection<MessageCS> MessagesList = new ObservableCollection<MessageCS>();

        public MsgConsoleCS()
        {
        }
        public MsgConsoleCS(DateTime dt, string category, string ObjName, string message)
        {
            this.MessagesList.Insert(0, new MessageCS() { DT = dt, Category = category, ObjectName = ObjName, Message = message });
        }
        public void Save(string LogPath)
        {
            string FIleName = Path.Combine(LogPath, DateTime.Now.ToString("yyyyMMdd") + "_msgs.gcflog");
            StreamWriter sw = new StreamWriter(FIleName, true);
            for (int i = 0; i < this.MessagesList.Count; i++)
            {
                MessageCS msg = this.MessagesList[i];
                sw.WriteLine(msg.ToString());
            }
            sw.Flush();
            sw.Close();
        }
    }

    public class MessageCS
    {
        public DateTime DT { set; get; }
        public string Category { set; get; }
        public string ObjectName { set; get; }
        public string Message { set; get; }
        public Brush BckColor
        {
            get
            {
                switch (this.Category)
                {
                    case "A": return Brushes.Red;
                    case "E": return Brushes.LightPink;
                    case "W": return Brushes.Yellow;
                    case "M": return Brushes.LightGray;
                    case "C": return Brushes.LightGreen;
                    case "L": return Brushes.LightBlue;
                }
                return Brushes.White;
            }
        }

        public MessageCS() { }
        public MessageCS(DateTime dt, string category, string ObjName, string message)
        {
            this.DT = dt;
            this.Category = category;
            this.ObjectName = ObjName;
            this.Message = message;
        }
        public override string ToString()
        {
            string msg = "";
            msg = this.DT.ToString("yy/MM/dd HH:mm:ss.fff") + "\t" + this.Category + "\t" + this.ObjectName + "\t" + this.Message;
            return msg;
        }
    }
}
