﻿using System;

namespace GlobalCF
{
	public static class RSR2_GuardDetector_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0x10,
				DriverType = GKDriverType.RSR2_GuardDetector,
				UID = new Guid("501AA41F-248B-4A4E-982A-6BC93505C7A9"),
				Name = "Извещатель охранный поверхностный ИО 30920-1/объемный ИО 40920-1",
				ShortName = "ИО-ИК",
				HasZone = false,
				HasGuardZone = true,
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.IntruderDetector
			};

			GKDriversHelper.AddControlAvailableStates(driver);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire1);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Fire1);
			driver.AvailableStateBits.Add(GKStateBit.Off);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InManual);
			
			GKDriversHelper.AddIntProprety(driver, 0, "Уровень в ед АЦП, с", 128, 16, 384);

			return driver;
		}
	}
}