﻿using System;

namespace GlobalCF
{
	public static class RSR2_HandGuardDetector_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xEF,
				DriverType = GKDriverType.RSR2_HandGuardDetector,
				UID = new Guid("BD3A0139-D9FD-4224-B5D6-8772BA9E3760"),
				Name = "Извещатель магнитоуправляемый ИО 10220-1",
				ShortName = "ИОВ",
				HasGuardZone = true,
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.IntruderDetector
			};

			GKDriversHelper.AddControlAvailableStates(driver);

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire1);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Fire1);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);
			driver.AvailableStateBits.Add(GKStateBit.Off);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InManual);

			var property1 = new GKDriverProperty()
			{
				No = 0,
				Name = "Конфигурация",
				Caption = "Конфигурация",
				Default = 1
			};
			var property1Parameter1 = new GKDriverPropertyParameter()
			{
				Name = "Система охранная",
				Value = 0
			};
			var property1Parameter2 = new GKDriverPropertyParameter()
			{
				Name = "Система контроля доступа",
				Value = 1
			};
			property1.Parameters.Add(property1Parameter1);
			property1.Parameters.Add(property1Parameter2);
			driver.Properties.Add(property1);

			return driver;
		}
	}
}