﻿using System;

namespace GlobalCF
{
	public static class RSR2_IDMS_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xCF,
				DriverType = GKDriverType.RSR2_IDMS,
				UID = new Guid("DF7C55FE-AFCE-4202-9FA1-1E625B61288C"),
				Name = "Извещатель дискретный модуля связи",
				ShortName = "ИДМС",
				IsPlaceable = true,
			};

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire1);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire2);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.Test);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.Fire2);

			GKDriversHelper.AddIntProprety(driver, 0, "Адрес RS-485 (привязка 1)", 1, 1, 247, true);
			GKDriversHelper.AddIntProprety(driver, 0, "", 0xCF, 0xCF, 0xCF, false, true, true);
			GKDriversHelper.AddIntProprety(driver, 1, "Адрес регистра данных (привязка 2)", 1, 1, 65535);
			var property2 = new GKDriverProperty()
			{
				No = 2,
				Name = "Команда чтения регистра",
				Caption = "Команда чтения регистра",
				Default = 1
			};
			GKDriversHelper.AddPropertyParameter(property2, "0x01", 1);
			GKDriversHelper.AddPropertyParameter(property2, "0x03", 3);
			GKDriversHelper.AddPropertyParameter(property2, "0x04", 4);
			driver.Properties.Add(property2);

			return driver;
		}
	}
}