﻿using System;

namespace GlobalCF
{
	public static class RSR2_IMMS_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xC4,
				DriverType = GKDriverType.RSR2_IMMS,
				UID = new Guid("C0EE8FB4-FFE6-4E6B-A957-35206ED0E13B"),
				Name = "Извещатель модификационный модуль связи",
				ShortName = "ИММС",
				IsPlaceable = true,
			};

			GKDriversHelper.AddIntProprety(driver, 0, "Адрес RS-485 (привязка 1)", 1, 1, 247, true);
			GKDriversHelper.AddIntProprety(driver, 0, "", 0xC4, 0xC4, 0xC4, false, true, true);
			GKDriversHelper.AddIntProprety(driver, 1, "Адрес регистра данных (привязка 2)", 1, 1, 65535);
			var property2 = new GKDriverProperty()
			{
				No = 2,
				Name = "Команда чтения регистра",
				Caption = "Команда чтения регистра",
				Default = 3
			};
			GKDriversHelper.AddPropertyParameter(property2, "0x03", 3);
			GKDriversHelper.AddPropertyParameter(property2, "0x04", 4);
			driver.Properties.Add(property2);

			GKDriversHelper.AddIntProprety(driver, 3, "Адрес регистра записи(привязка 3)", 0, 0, 65535);
			GKDriversHelper.AddIntProprety(driver, 4, "Новое значение", 0, 0, 65535);

			var property3 = new GKDriverProperty()
			{
				No = 5,
				Name = "Смена скорости обмена",
				Caption = "Смена скорости обмена",
				Default = 0,
				Mask = 1
			};
			GKDriversHelper.AddPropertyParameter(property3, "При смене значения ячейки скорость не меняется", 0);
			GKDriversHelper.AddPropertyParameter(property3, "При смене значения ячейки скорость меняется", 1);
			driver.Properties.Add(property3);

			var property4 = new GKDriverProperty()
			{
				No = 5,
				Name = "Подтверждение чтением из ячейки с адресом в приявязке 2",
				Caption = "Подтверждение чтением из ячейки с адресом в приявязке 2",
				Default = 0,
				Mask = 2
			};
			GKDriversHelper.AddPropertyParameter(property4, "Не считывать", 0);
			GKDriversHelper.AddPropertyParameter(property4, "Считывать", 2);
			driver.Properties.Add(property4);

			return driver;
		}
	}
}