﻿using System;

namespace GlobalCF
{
	public static class RSR2_IVEPR_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xD5,
				DriverType = GKDriverType.RSR2_IVEPR,
				UID = new Guid("CD3F6C78-F9E9-4386-AA14-C1472B2D20BD"),
				Name = "Источник вторичного электропитания резервированный адресный",
				ShortName = "ИВЭПР",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.Other
			};

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Unknown);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOnNow_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InManual);
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOffNow_InManual);

			GKDriversHelper.AddIntProprety(driver, 0, "U сети мин, B", 150, 130, 270);
			GKDriversHelper.AddIntProprety(driver, 1, "U сети макс, B", 250, 130, 270);
			GKDriversHelper.AddIntProprety(driver, 2, "Ток нагрузки, мА", 5500, 0, 7000);
			GKDriversHelper.AddIntProprety(driver, 3, "U АБК, 0.1B", 264, 0, 300);

			driver.MeasureParameters.Add(new GKMeasureParameter { No = 1, Name = "Ток нагрузки, мА" });
			driver.MeasureParameters.Add(new GKMeasureParameter { No = 2, Name = "U вых, B", Multiplier = 10 });
			driver.MeasureParameters.Add(new GKMeasureParameter { No = 3, Name = "U АКБ, В", Multiplier = 10 });
			driver.MeasureParameters.Add(new GKMeasureParameter { No = 4, Name = "U сети, В" });

			return driver;
		}
	}
}