﻿using System;

namespace GlobalCF
{
	public static class RSR2_IVMS_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xCA,
				DriverType = GKDriverType.RSR2_IVMS,
				UID = new Guid("F9E53403-1BB8-4AE5-AD41-D93BA6EAB675"),
				Name = "Извещатель модуля связи с вещественным значением",
				ShortName = "ИВМС",
				IsPlaceable = true,
			};

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire1);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Fire2);

			GKDriversHelper.AddIntProprety(driver, 0, "Адрес RS-485 (привязка 1)", 1, 1, 247, true);
			GKDriversHelper.AddIntProprety(driver, 0, "", 0xCA, 0xCA, 0xCA, false, true, true);
			GKDriversHelper.AddIntProprety(driver, 1, "Адрес регистра данных (привязка 2)", 1, 1, 65535);
			var property2 = new GKDriverProperty()
			{
				No = 2,
				Name = "Команда чтения регистра",
				Caption = "Команда чтения регистра",
				Default = 3
			};
			GKDriversHelper.AddPropertyParameter(property2, "0x03", 3);
			GKDriversHelper.AddPropertyParameter(property2, "0x04", 4);
			driver.Properties.Add(property2);

			var property3 = new GKDriverProperty()
			{
				No = 3,
				Name = "Конфигурация сработки",
				Caption = "Конфигурация сработки",
				Default = 0,
				Mask = 1
			};
			GKDriversHelper.AddPropertyParameter(property3, "Один порог", 0);
			GKDriversHelper.AddPropertyParameter(property3, "Два порога", 1);
			driver.Properties.Add(property3);


			var property4 = new GKDriverProperty()
			{
				No = 3,
				Name = "Условие сработки",
				Caption = "Условие сработки",
				Default = 0,
				Mask = 2
			};
			GKDriversHelper.AddPropertyParameter(property4, "Увеличение", 0);
			GKDriversHelper.AddPropertyParameter(property4, "Уменьшение", 2);
			driver.Properties.Add(property4);

			GKDriversHelper.AddIntProprety(driver, 4, "Порог 1 - Старшее слово", 0, 0, 65535).CanNotEdit = true;
			GKDriversHelper.AddIntProprety(driver, 5, "Порог 1 - Младшее слово", 0, 0, 65535).CanNotEdit = true;

			GKDriversHelper.AddIntProprety(driver, 6, "Порог 2 - Старшее слово", 0, 0, 65535).CanNotEdit = true;
			GKDriversHelper.AddIntProprety(driver, 7, "Порог 2 - Младшее слово", 0, 0, 65535).CanNotEdit = true;

			return driver;
		}
	}
}