﻿using System;

namespace GlobalCF
{
	public static class RSR2_MI_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0x25,
				DriverType = GKDriverType.RSR2_MI,
				UID = new Guid("A0F70D76-A348-4ABA-A68E-531C6F6B1461"),
				Name = "Модуль-изолятор",
				ShortName = "МИ",
				IsPlaceable = true,

				DriverClassification = GKDriver.DriverClassifications.Other
			};
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Test);
			GKDriversHelper.AddAvailableStateClasses(driver, XStateClass.Unknown);

			GKDriversHelper.AddIntProprety(driver, 0, "Порог по питанию  в 0.1В", 120, 100, 300);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InAutomatic, 0, "Включить АЛС1");
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InAutomatic, 1, "Включить АЛС2");
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InAutomatic, 0, "Выключить АЛС1");
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InAutomatic, 1, "Выключить АЛС2");

			GKDriversHelper.AddIntProprety(driver, 0, "Порог по питанию, B", 180, 100, 300).Multiplier = 10;

			driver.AvailableStateBits.Add(GKStateBit.Test);
			driver.AvailableStateBits.Add(GKStateBit.Failure);

			driver.MeasureParameters.Add(new GKMeasureParameter() { No = 1, Name = "I АЛС1, мА" });
			driver.MeasureParameters.Add(new GKMeasureParameter() { No = 2, Name = "I АЛС2, мА" });
			driver.MeasureParameters.Add(new GKMeasureParameter() { No = 3, Name = "U, В", Multiplier = 10});

			return driver;
		}
	}
}
