﻿using System;

namespace GlobalCF
{
	public static class RSR2_MSP_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xC8,
				DriverType = GKDriverType.RSR2_MSP,
				UID = new Guid("391D8F9A-0F86-4DF8-826E-B77E21B853B9"),
				Name = "Модуль связи подчиненный",
				ShortName = "МСП",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.Other
			};

			driver.Children.Add(GKDriverType.RSR2_OMSP);

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);

			GKDriversHelper.AddIntProprety(driver, 0, "Число подчиненных адресных устройств (ПАУ)", 0, 0, 250);
			GKDriversHelper.AddIntProprety(driver, 1, "Адрес устройства MODBUS/RTU", 1, 1, 247);
			GKDriversHelper.AddIntProprety(driver, 2, "Порог питания АЛС(ед.мл.разряда - 0.1В)", 120, 0, 363);

			return driver;
		}
	}
}