﻿using System;

namespace GlobalCF
{
	public static class RSR2_MSV_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xD0,
				DriverType = GKDriverType.RSR2_MSV,
				UID = new Guid("E3BF33FA-8650-47F1-B182-162161CAF077"),
				Name = "Модуль связи ведущий",
				ShortName = "МСВ",
				IsPlaceable = true,
				DriverClassification = GKDriver.DriverClassifications.Other
			};

			driver.Children.Add(GKDriverType.RSR2_IDMS);
			driver.Children.Add(GKDriverType.RSR2_IZMS);
			driver.Children.Add(GKDriverType.RSR2_IVMS);
			driver.Children.Add(GKDriverType.RSR2_IMMS);
			driver.Children.Add(GKDriverType.RSR2_IPS);

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);

			GKDriversHelper.AddIntProprety(driver, 0, "Число подчиненных адресных устройств (ПАУ)", 0, 0, 250);
			GKDriversHelper.AddIntProprety(driver, 1, "Порог питания АЛС (ед.мл.разряда - 0.1В)", 120, 0, 363);

			return driver;
		}
	}
}