﻿using System;

namespace GlobalCF
{
	public static class RSR2_OMSP_Helper
	{
		public static GKDriver Create()
		{
			var driver = new GKDriver()
			{
				DriverTypeNo = 0xC9,
				DriverType = GKDriverType.RSR2_OMSP,
				UID = new Guid("9324C68B-3B66-4176-A31F-281B5380CA9F"),
				Name = "Сигнал МСП",
				ShortName = "ОМСП",
				HasLogic = true,
				IsPlaceable = true,
				IsControlDevice = true
			};

			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Test);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.On);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Off);
			GKDriversHelper.AddAvailableStateBits(driver, GKStateBit.Failure);

			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOn_InManual, 0, "Пуск");
			GKDriversHelper.AddCommandBit(driver, GKStateBit.TurnOff_InManual, 0, "Стоп");

			return driver;
		}
	}
}